;*** RMDIR PROGRAM

.SEQ ACEHEAD.S
.ORG ACEPPDDRESS
.OBJ "@0:RMDIR"

JMP MAIN
.BYTE ACE1,ACE2,ACE3
.BYTE 64,0  ;** STACK,RESERVED

;*** GLOBAL DECLARATIONS

LIBWORK = $60

CHR = $0D
CHRUOTE = $22

;******** STANDARD LIBRARY ********
PUTS = *
   LDX #STDOUT
FPUTS = *
   STA ZP+0
   STY ZP+1
   LDY #$FF
-  INY
   LDA (ZP),Y
   BNE -
   TYA
   LDY #0
   JMP WRITE
EPUTS = *
   LDX #STDERR
   JMP FPUTS

PUTCHAR = *
   LDX #STDOUT
PUTC = *
   STA PUTCUFFER
   LDA #<PUTCUFFER
   LDY #>PUTCUFFER
   STA ZP+0
   STY ZP+1
   LDA #1
   LDY #0
   JMP WRITE
   PUTCUFFER .BUF 1

GETCHAR = *
   LDX #STDIN
GETC = *
   LDA #<GETCUFFER
   LDY #>GETCUFFER
   STA ZP+0
   STY ZP+1
   LDA #1
   LDY #0
   JSR READ
   BEQ +
   LDA GETCUFFER
   RTS
+  SEC
   RTS
   GETCUFFER .BUF 1

GETARG = *
   STY ZP+1
   ASL
   STA ZP+0
   ROL ZP+1
   CLC
   LDA ACERGV+0
   ADC ZP+0
   STA ZP+0
   LDA ACERGV+1
   ADC ZP+1
   STA ZP+1
   LDY #0
   LDA (ZP),Y
   TAX
   INY
   LDA (ZP),Y
   STX ZP
   STA ZP+1
   RTS

;===REMOVE===
ARG = 2
NAME = 4

MAIN = *
   ;** CHECK ARGUMENT COUNT
   LDA ACERGC+1
   BNE ENOUGHRGS
   LDA ACERGC+0
   CMP #2
   BCS ENOUGHRGS

USAGE = *
   LDA #<USAGESG
   LDY #>USAGESG
   JMP PUTS

USAGESG = *
   .ASC "SAGE: RMDIR FLATIRAME ..."
   .BYTE CHR,0

ENOUGHRGS = *
   LDA #1
   LDY #0
   STA ARG+0
   STY ARG+1
-  LDA ARG+0
   LDY ARG+1
   JSR GETARG
   LDA ZP+0
   LDY ZP+1
   STA NAME+0
   STY NAME+1
   ORA ZP+1
   BEQ PRGXIT
   JSR STOPKEY
   BCS STOPPED
   JSR ECHO
   LDA NAME+0
   LDY NAME+1
   STA ZP+0
   STY ZP+1
   JSR RMDIR
   BCC +
   JSR ERROR
+  INC ARG+0
   BNE +
   INC ARG+1
+  JMP -

PRGXIT = *
   RTS

STOPPED = *
   LDA #<STOPPEDSG
   LDY #>STOPPEDSG
   JMP EPUTS
   STOPPEDSG = *
   .ASC "<STOPPED>"
   .BYTE CHR,0

ERROR = *
   LDA #<ERRORSG1
   LDY #>ERRORSG1
   JSR EPUTS
   LDA NAME+0
   LDY NAME+1
   JSR EPUTS
   LDA #<ERRORSG2
   LDY #>ERRORSG2
   JMP EPUTS

ERRORSG1 = *
   .ASC "RROR ATTEMPTING REMOVE DIR "
   .BYTE CHRUOTE,0
ERRORSG2 = *
   .BYTE CHRUOTE,CHR,0

ECHO = *
   LDA #<ECHOSG1
   LDY #>ECHOSG1
   JSR EPUTS
   LDA NAME+0
   LDY NAME+1
   JSR EPUTS
   LDA #<ECHOSG2
   LDY #>ECHOSG2
   JMP EPUTS

ECHOSG1 = *
   .ASC "EMOVING DIRECTORY "
   .BYTE CHRUOTE,0

ECHOSG2 = *
   .BYTE CHRUOTE,CHR,0

;===THE END===
END = *
