;***  FILE DECODER VERSION 1.00 - BY RAIG RUCE - 05-AR-94

;UNKAR [-HELP] FILE ...

;EVIN'S CHIVER FORMAT, CREATED BY EVIN HILLIPS AND RAIG RUCE, 1991
;LINE LENGTH LIMITED TO 250 CHARACTERS

.SEQ ACEHEAD.S
.ORG ACEPPDDRESS
.OBJ "@0:UNKAR"

JMP MAIN
.BYTE ACE1,ACE2,ACE3
.BYTE 64,0  ;** STACK,RESERVED

;*** GLOBAL DECLARATIONS

CHR = $07
CHR = $09
CHR = $0A
CHR = $0D
CHR = $14
CHR = $93
CHR = $22

ARG          =  2 ;(2)  ;CURRENT ARGUMENT NUMBER
NAME         =  4 ;(2)  ;NAME OF FILE BEING BCODED
INUFTR     =  6 ;(2)  ;NEXT CHAR TO EXTRACT FROM INUF
INUFOUNT   =  8 ;(2)  ;NUMBER OF VALID CHARS IN INUF
INUFEN     = 10 ;(2)  ;TOTAL SIZE OF INPUT BUFFER
SCANAL      = 12 ;(4)  ;SCANUM: VALUE RETURNED
SCANAVE     = 16 ;(4)  ;SCANUM: SAVE FOR *4 TO *5
SCANIGIT    = 20 ;(1)  ;SCANUM: NEW DIGIT
SCANEMP     = 21 ;(1)  ;SCANUM: TEMP
SCANNDEX    = 22 ;(1)  ;SCANUM: SCANNING INDEX
SCANNYTHING = 23 ;(1)  ;SCANUM: FLAG FOR IF ANYTHING SCANNED
FILEOUNT    = 24 ;(4)  ;FILES LEFT IN CURRENT ARCHIVE
LINEOUNT    = 28 ;(4)  ;LINES LEFT IN CURRENT FILE
INILE       = 32 ;(1)  ;INPUT FILE DESCRIPTOR
OUTILE      = 33 ;(1)  ;OUTPUT FILE DESCRIPTOR
WORK         = 112 ;(16);TEMPORARY WORK AREA, LOWEST LEVEL

;===MAIN===

MAIN = *
   ;** CHECK FOR LARGE ENOUGH 
   SEC
   LDA #<BSSND
   CMP ACEEMOP+0
   LDA #>BSSND
   SBC ACEEMOP+1
   BCS +
   JMP MAINNIT
+  LDA #<TPASG
   LDY #>TPASG
   JSR EPUTS
DIE = *
   LDA #1
   LDX #0
   JMP EXIT

TPASG = *
   .ASC "NSUFFICIENT PROGRAM SPACE TO RUN MORE"
   .BYTE CHR,0

USAGE = *
   LDA #<USAGESG
   LDY #>USAGESG
   JSR EPUTS
   JMP DIE

USAGESG = *
   .ASC "USAGE: UNKAR [-HELP] FILE ..."
   .BYTE CHR,0

MAINNIT = *
   LDA #0
   STA ARG+0
   STA ARG+1

   MAINEXT = *
   JSR CHECKTOP
   INC ARG+0
   BNE +
   INC ARG+1
+  LDA ARG+0
   LDY ARG+1
   JSR GETARG
   BEQ MAINXIT
   LDA ZP+0
   LDY ZP+1
   STA NAME+0
   STY NAME+1
   LDY #0
   LDA (ZP),Y
   CMP #"-"
   BNE +
   JMP USAGE
+  JSR UNKAR
   JMP MAINEXT

MAINXIT = *
   RTS

CHECKTOP = *
   JSR STOPKEY
   BCS +
   RTS
+  LDA #<STOPPEDSG
   LDY #>STOPPEDSG
   JSR EPUTS
   JMP DIE

   STOPPEDSG = *
   .ASC "<TOPPED>"
   .BYTE CHR,0

UNKAR = *
   JSR ECHO
   ;** OPEN FILE
   LDA NAME+0
   LDY NAME+1
   STA ZP+0
   STY ZP+1
   LDA #"R"
   JSR OPEN
   BCC +
   ;XX OPEN ERROR
   RTS
+  STA INILE
   JSR INITETYTE
   ;** DECODE FILE
   JSR UNKARODY
   ;** CLOSE FILE
   LDA INILE
   JSR CLOSE
   RTS

INVALIDORMATSG = *
   .ASC ": INVALID  FILE FORMAT"
   .BYTE CHR,0
INVALIDORMAT = *
   LDA NAME+0
   LDY NAME+1
   JSR EPUTS
   LDA #<INVALIDORMATSG
   LDY #>INVALIDORMATSG
   JSR EPUTS
   RTS

UNKARODY = *
   ;** GET THE FILE COUNT
   JSR GETLINE
   BCS INVALIDORMAT
   LDX #FILEOUNT
   JSR GETNUM
   BCS INVALIDORMAT

   UNKAREXTILE = *
   JSR CHECKTOP
   LDA FILEOUNT+0
   ORA FILEOUNT+1
   ORA FILEOUNT+2
   ORA FILEOUNT+3
   BNE +
   RTS
   ;** GET FILENAME
+  JSR GETLINE
   BCS INVALIDORMAT
   JSR ECHOXTRACT
   LDA #<LINE
   LDY #>LINE
   STA ZP+0
   STY ZP+1
   LDA #"W"
   JSR OPEN
   BCC +
   ;XX CHECK FOR FILE EXISTS
   LDA #<LINE
   LDY #>LINE
   JSR EPUTS
   LDA #<CANNOTPENSG
   LDY #>CANNOTPENSG
   JSR EPUTS
   RTS
+  STA OUTILE
   ;** GET FILE LINE COUNT
   JSR GETLINE
   BCS INVALIDORMATLOSE
   LDX #LINEOUNT
   JSR GETNUM
   BCC UNKAREXTINE
   INVALIDORMATLOSE = *
   LDA OUTILE
   JSR CLOSE
   JMP INVALIDORMAT

   UNKAREXTINE = *
   LDA LINEOUNT+0
   ORA LINEOUNT+1
   ORA LINEOUNT+2
   ORA LINEOUNT+3
   BNE +
   LDA OUTILE
   JSR CLOSE
   LDX #FILEOUNT
   JSR DEC32
   JMP UNKAREXTILE

   ;** COPY LINES OF FILE
+  JSR GETLINE
   BCS INVALIDORMATLOSE
   LDA #CHR
   STA LINE,Y
   INY
   LDA #<LINE
   LDX #>LINE
   STA ZP+0
   STX ZP+1
   TYA
   LDY #0
   LDX OUTILE
   JSR WRITE
   LDX #LINEOUNT
   JSR DEC32
   JMP UNKAREXTINE

   CANNOTPENSG = *
   .ASC ": CANNOT OPEN FOR WRITING"
   .BYTE CHR,0

DEC32 = *
   CLC
   LDY #4
-  LDA 0,X
   SBC #0
   STA 0,X
   INX
   DEY
   BNE -
   RTS

ECHO = *
   LDA #<ECHOSG1
   LDY #>ECHOSG1
   JSR EPUTS
   LDA NAME+0
   LDY NAME+1
   JSR EPUTS
   LDA #<ECHOSG2
   LDY #>ECHOSG2
   JMP EPUTS
ECHOSG1 = *
   .ASC "UNKARING FILE "
   .BYTE CHR,0
ECHOSG2 = *
   .BYTE CHR,CHR,0

ECHOXTRACT = *
   LDA #<ECHOXTRACTSG1
   LDY #>ECHOXTRACTSG1
   JSR EPUTS
   LDA #<LINE
   LDY #>LINE
   JSR EPUTS
   LDA #<ECHOXTRACTSG2
   LDY #>ECHOXTRACTSG2
   JMP EPUTS
ECHOXTRACTSG1 = *
   .ASC "EXTRACTING FILE "
   .BYTE CHR,0
ECHOXTRACTSG2 = *
   .BYTE CHR,CHR,0

;=== STANDARD LIBRARY ===

PUTS = *
   LDX #STDOUT
FPUTS = *
   STA ZP+0
   STY ZP+1
   LDY #$FF
-  INY
   LDA (ZP),Y
   BNE -
   TYA
   LDY #0
   JMP WRITE
EPUTS = *
   LDX #STDERR
   JMP FPUTS

EPUTCHAR = *
   LDX #STDERR
   JMP PUTC
PUTCHAR = *
   LDX #STDOUT
PUTC = *
   STA PUTCUFFER
   LDA #<PUTCUFFER
   LDY #>PUTCUFFER
   STA ZP+0
   STY ZP+1
   LDA #1
   LDY #0
   JMP WRITE
   PUTCUFFER .BUF 1

GETARG = *
   STY ZP+1
   ASL
   STA ZP+0
   ROL ZP+1
   CLC
   LDA ACERGV+0
   ADC ZP+0
   STA ZP+0
   LDA ACERGV+1
   ADC ZP+1
   STA ZP+1
   LDY #0
   LDA (ZP),Y
   TAX
   INY
   LDA (ZP),Y
   STX ZP+0
   STA ZP+1
   ORA ZP+0
   RTS

GETLINE = *  ;( ) : LINE, .=LINEEN, .=EOF
   LDY #0
-  STY WORK+0
   JSR GETYTE
   BCC +
   RTS
+  LDY WORK+0
   STA LINE,Y
   INY
   CPY #254
   BCS GETLINEKIP
   CMP #CHR
   BNE -
   DEY

   GETLINEXIT = *
   LDA #0
   STA LINE,Y
   CLC
   RTS

   GETLINEKIP = *
   LDA #<GETLINEOOONGSG
   LDY #>GETLINEOOONGSG
   JSR EPUTS
-  JSR GETYTE
   BCC +
   RTS
+  CMP #CHR
   BNE -
   LDY #254
   JMP GETLINEXIT

   GETLINEOOONGSG = *
   .ASC "UNKAR: LINE TOO LONG, TRUNCATING"
   .BYTE CHR,0

INITETYTE = *
   LDA #0
   STA INUFOUNT+0
   STA INUFOUNT+1
   SEC
   LDA ACEEMOP+0
   SBC #<INUF
   STA INUFEN+0
   LDA ACEEMOP+1
   SBC #>INUF
   STA INUFEN+1
   RTS

GETYTE = *
   LDA INUFOUNT+0
   ORA INUFOUNT+1
   BEQ GETYTEILLUF
   LDY #0
   LDA (INUFTR),Y
   INC INUFTR+0
   BNE +
   INC INUFTR+1
+  LDX INUFOUNT+0
   BNE +
   DEC INUFOUNT+1
+  DEC INUFOUNT+0
   CLC
   RTS

GETYTEILLUF = *
   JSR CHECKTOP
   LDA #<INUF
   LDY #>INUF
   STA ZP+0
   STY ZP+1
   STA INUFTR+0
   STY INUFTR+1
   LDA INUFEN+0
   LDY INUFEN+1
   LDX INILE
   JSR READ
   BEQ +
   BCS +
   STA INUFOUNT+0
   STY INUFOUNT+1
   JMP GETYTE
+  SEC
   RTS

SCANUM = *  ;( (ZP)=NUM, .=ININENDEX ) : .=SCAN, [SCANAL]=NUM, .=ERR
   LDX #3
   LDA #0
-  STA SCANAL,X
   DEX
   BPL -
   LDA #0
   STA SCANNYTHING
-  LDA (ZP),Y
   CMP #" "
   BNE SCANUMEXT
   INY
   BNE -
   SEC
   RTS

   SCANUMEXT = *
   LDA (ZP),Y
   CMP #"0"
   BCC +
   CMP #"9"+1
   BCC ++
+  LDA SCANNYTHING
   BEQ SCANRROR
   CLC
   RTS
+  AND #$0F
   STA SCANIGIT
   LDA #$FF
   STA SCANNYTHING
   ;** TIMES TEN
   STY SCANEMP
   LDX #3
-  LDA SCANAL,X
   STA SCANAVE,X
   DEX
   BPL -
   LDA #2
   STA SCANNDEX
-  CLC
   LDY #4
   LDX #0
-  ROL SCANAL,X
   INX
   DEY
   BNE -
   BCS SCANRROR
   DEC SCANNDEX
   BNE --
   CLC
   LDY #4
   LDX #0
-  LDA SCANAL,X
   ADC SCANAVE,X
   STA SCANAL,X
   INX
   DEY
   BNE -
   BCS SCANRROR
   CLC
   LDY #4
   LDX #0
-  ROL SCANAL,X
   INX
   DEY
   BNE -
   BCS SCANRROR
   CLC
   LDY #4
   LDX #0
   LDA SCANIGIT
-  ADC SCANAL,X
   STA SCANAL,X
   LDA #0
   INX
   DEY
   BNE -
   BCS SCANRROR

   LDY SCANEMP
   INY
   BEQ SCANRROR
   JMP SCANUMEXT

   SCANRROR = *
   SEC
   RTS

GETNUM = *  ;( LINE, .=ZPADDR ) : .=ERR
   STX WORK+0
   LDA #<LINE
   LDY #>LINE
   STA ZP+0
   STY ZP+1
   LDY #0
   JSR SCANUM
   BCC +
   RTS
+  LDY #0
   LDX WORK+0
-  LDA SCANAL,Y
   STA 0,X
   INX
   INY
   CPY #4
   BCC -
   CLC
   RTS

;===BSS===

BSS    = *
LINE   = BSS+0  
INUF  = LINE+256
BSSND = INUF+64
