;** ASSEMBLER PROGRAM UTILITY FILE - BY RAIG RUCE - 26-EP-1994

;======== ASSEMBLE PROCESSOR INSTRUCTION ========

; NUM BKT INS     NUM BKT INS     NUM BKT INS     NUM BKT INS     NUM BKT INS
; 00. XX. XXX     12. 63. BVC     24. 22. EOR     36. 20. PHA     48. 27. STA
; 01. 12. ADC     13. 15. BVS     25. 05. INC     37. 35. PHP     49. 50. STX
; 02. 63. AND     14. 38. CLC     26. 26. INX     38. 40. PLA     50. 51. STY
; 03. 00. ASL     15. 39. CLD     27. 27. INY     39. 55. PLP     51. 12. TAX
; 04. 00. BCC     16. 44. CLI     28. 06. JMP     40. 20. ROL     52. 13. TAY
; 05. 16. BCS     17. 57. CLV     29. 38. JSR     41. 26. ROR     53. 38. TSX
; 06. 24. BEQ     18. 24. CMP     30. 28. LDA     42. 10. RTI     54. 08. TXA
; 07. 47. BIT     19. 15. CPX     31. 51. LDX     43. 20. RTS     55. 26. TXS
; 08. 56. BMI     20. 16. CPY     32. 52. LDY     44. 03. SBC     56. 45. TYA
; 09. 25. BNE     21. 60. DEC     33. 24. LSR     45. 50. SEC
; 10. 42. BPL     22. 17. DEX     34. 52. NOP     46. 51. SED
; 11. 51. BRK     23. 18. DEY     35. 45. ORA     47. 56. SEI

INSTRAMES = *  ;NAMES OF INSTRUCTION, 3 CHARS EACH
   .ASC "XXXADCANDASLBCCBCSBEQBITBMIBNEBPLBRKBVCBVSCLCCLDCLICLVCMPCPXCPY"
   .ASC "DECDEXDEYEORINCINXINYJMPJSRLDALDXLDYLSRNOPORAPHAPHPPLAPLPROLROR"
   .ASC "RTIRTSSBCSECSEDSEISTASTXSTYTAXTAYTSXTXATXSTYA"

INSTRASHTRS = *  ;POINTERS TO INSTRUCTION NUMBERS OR >=100=INDIRECTS
   ;BUCKETX0..X1..X2..X3..X4..X5..X6..X7..X8..X9
   .BYTE 100,000,000,044,000,025,028,000,054,000  ;BUCKETS 00-09
   .BYTE 042,000,103,052,000,106,109,022,023,000  ;BUCKETS 10-19
   .BYTE 112,000,024,000,116,009,120,124,030,000  ;BUCKETS 20-29
   .BYTE 000,000,000,000,000,037,000,000,127,015  ;BUCKETS 30-39
   .BYTE 038,000,010,000,016,131,000,007,000,000  ;BUCKETS 40-49
   .BYTE 134,137,142,000,000,039,145,017,000,000  ;BUCKETS 50-59
   .BYTE 021,000,000,148                          ;BUCKETS 60-63

INSTRASHNDIRECTS = *
   .BYTE 004,003,000     ;OFF=100, BUCKET=00, INSTRS=BCC,ASL
   .BYTE 001,051,000     ;OFF=103, BUCKET=12, INSTRS=ADC,TAX
   .BYTE 019,013,000     ;OFF=106, BUCKET=15, INSTRS=CPX,BVS
   .BYTE 005,020,000     ;OFF=109, BUCKET=16, INSTRS=BCS,CPY
   .BYTE 043,036,040,000 ;OFF=112, BUCKET=20, INSTRS=RTS,PHA,ROL
   .BYTE 006,018,033,000 ;OFF=116, BUCKET=24, INSTRS=BEQ,CMP,LSR
   .BYTE 026,041,055,000 ;OFF=120, BUCKET=26, INSTRS=INX,ROR,TXS
   .BYTE 048,027,000     ;OFF=124, BUCKET=27, INSTRS=STA,INY
   .BYTE 029,014,053,000 ;OFF=127, BUCKET=38, INSTRS=JSR,CLC,TSX
   .BYTE 035,056,000     ;OFF=131, BUCKET=45, INSTRS=ORA,TYA
   .BYTE 049,045,000     ;OFF=134, BUCKET=50, INSTRS=STX,SEC
   .BYTE 031,050,011,046,000;OFF=137,BUCK=51, INSTRS=LDX,STY,BRK,SED
   .BYTE 032,034,000     ;OFF=142, BUCKET=52, INSTRS=LDY,NOP
   .BYTE 008,047,000     ;OFF=145, BUCKET=56, INSTRS=BMI,SEI
   .BYTE 002,012,000     ;OFF=148, BUCKET=63, INSTRS=AND,BVC

PARSEDHECKNSTR = *  ;( .=INSTRUMOHECK ) : .=NOTNSTR, .+.:UNCH
   STA WORK
   ASL
   ADC WORK
   TAY
   LDA STRINGUF+0
   CMP INSTRAMES+0,Y
   BNE +
   LDA STRINGUF+1
   CMP INSTRAMES+1,Y
   BNE +
   LDA STRINGUF+2
   CMP INSTRAMES+2,Y
   BNE +
   CLC
   LDA WORK
   RTS
+  SEC
   RTS

INSTR = *  ;( .=INSTRUM )
   ;** GOT INSTRUCTION NUMBER
   STA INSTRUM
   BIT ORIGINET
   BMI +
   LDA #ERRRIGINOTET
   JMP ERROR
+  BIT DEBUG
   BPL +
   STA NUMBER+0
   LDA #0
   STA NUMBER+1
   STA NUMBER+2
   STA NUMBER+3
   LDA #<INSTRSG
   LDY #>INSTRSG
   JSR PUTS
   LDX #NUMBER
   JSR PUTNUM
   LDA #CHR
   JSR PUTCHAR

   ;** GET ADDRESSING MODE AND VALUE
+  JSR INSTRETDDRODE
   BIT DEBUG
   BPL +++
   LDA INSTRDDRODE
   STA NUMBER+0
   LDA #0
   STA NUMBER+1
   STA NUMBER+2
   STA NUMBER+3
   LDA #<INSTRDDRSG1
   LDY #>INSTRDDRSG1
   JSR PUTS
   LDX #NUMBER
   JSR PUTNUM
   LDA #<INSTRDDRSG2
   LDY #>INSTRDDRSG2
   JSR PUTS
   LDA INSTRALUE+0
   LDY INSTRALUE+1
   STA NUMBER+0
   STY NUMBER+1
   LDA INSTRALUEYPE
   BMI +
   LDX #NUMBER
   JSR PUTNUM
   JMP ++
+  LDA #"?"
   JSR PUTCHAR
+  LDA #CHR
   JSR PUTCHAR

   ;** GET OPCODE FOR INSTR/ADDRMODE
+  NOP
-  LDA INSTRUM
   LDX INSTRDDRODE
   JSR INSTRETPCODE
   BCC +
   LDX INSTRDDRODE
   LDA INSTRDMODEROMOTE,X
   STA INSTRDDRODE
   BNE -
   LDA #ERRRONGDMODE
   JMP ERROR
+  BIT DEBUG
   BPL ++
   LDA #<INSTRODESG
   LDY #>INSTRODESG
   JSR PUTS
   LDA ADDRESS+1
   JSR PUTHEX
   LDA ADDRESS+0
   JSR PUTHEX
   LDA #":"
   JSR PUTCHAR
   LDA #" "
   JSR PUTCHAR
   LDA INSTRPCODE
   JSR PUTHEX
   LDA INSTREN
   CMP #1
   BEQ +
   LDA #" "
   JSR PUTCHAR
   LDA INSTRALUE+0
   JSR PUTHEX
   LDA INSTREN
   CMP #2
   BEQ +
   LDA #" "
   JSR PUTCHAR
   LDA INSTRALUE+1
   JSR PUTHEX
+  LDA #CHR
   JSR PUTCHAR

   ;** STORE THE INSTRUCTION INTO MEMORY
+  LDA INSTRPCODE
   STA MEMUTALS+0
   LDA INSTRALUE+0
   LDY INSTRALUE+1
   STA MEMUTALS+1
   STY MEMUTALS+2
   LDX ADDRESS+0
   LDY ADDRESS+1
   LDA INSTREN
   JSR MEMUT

   ;** ADD RELOCATABLE REFERENCE
   LDA INSTRALUEYPE
   BEQ ++
   CMP #$04
   BCS ++
   LDX ADDRESS+0
   LDY ADDRESS+1
   INX
   BNE +
   INY
+  JSR RECORDELOCEF

   ;** INCREMENT ADDRESS AND FINISH
+  CLC
   LDA ADDRESS+0
   ADC INSTREN
   STA ADDRESS+0
   BCC +
   INC ADDRESS+1
   BNE +
   LDA #ERRDDRESSRAP
   JMP ERROR
+  JMP PARSEND

INSTRSG = *
   .ASC "GOT PROCESSOR INSTRUCTION="
   .BYTE 0
INSTRDDRSG1 = *
   .ASC "GOT ADDRESS MODE="
   .BYTE 0
INSTRDDRSG2 = *
   .ASC ", VALUE="
   .BYTE 0
INSTRODESG = *
   .ASC "CODE = "
   .BYTE 0
INSTRDMODEROMOTE = *
   .BYTE $00,$00,$00,$00,$07,$08,$09,$00,$00,$00,$00,$00,$00

; NUM  NAME       GEN  BYT  TOKENS
; ---  ---------  ---  ---  -------
; 00.  <NONE>     00.    0  <NONE>
; 01.  IMPLIED    00.    1  
; 02.  IMMEDIATE  00.    2  #     / EXP8  / 
; 03.  RELATIVE   00.    2  EXP16 / 
; 04.  ZEROPAGE   07.    2  EXP8  / 
; 05.  ZP,X       08.    2  EXP8  / ,     / X   / 
; 06.  ZP,Y       09.    2  EXP8  / ,     / Y   / 
; 07.  ABSOLUTE   00.    3  EXP16 / 
; 08.  ABS,X      00.    3  EXP16 / ,     / X   / 
; 09.  ABS,Y      00.    3  EXP16 / ,     / Y   / 
; 10.  INDIRECT   00.    3  (     / EXP16 / )   / 
; 11.  (IND,X)    00.    2  (     / EXP8  / ,   / X   / )  / 
; 12.  (IND),Y    00.    2  (     / EXP8  / )   / ,   / Y  / 
;
; LL ZP MODES CAN BE PROMOTED TO ABS EXCEPT FOR ZP,Y FOR STX AND ZP,X FOR STY.
; NDY MODE CAUSES SOME SPECIAL PROBLEMS--'LL HAVE TO PATCH THE HOLE.

INSTRETDDRODE = *  ;( ADDRESS, INSTRUM ) : INSTRDDRODE, INSTRALUE,
   LDA #$00             ;                        INSTRALUEYPE
   STA INSTRALUE+0
   STA INSTRALUE+1
   STA INSTRALUEYPE
   LDA TOKENEXTHAR
   CMP #"#"
   BEQ ADMODEMMEDIATE
   CMP #"("
   BEQ ADMODENDIRECT
   CMP #CHR
   BNE +
   JSR GETOKEN  ;GET THE 
   LDA #01       ;IMPLIED
   STA INSTRDDRODE
   RTS
+  LDA INSTRUM
   CMP #14
   BCS +
   CMP #4
   BCC +
   CMP #7
   BEQ +
   CMP #11
   BEQ +
   JMP ADMODEELATIVE
   ;** ZP OR ABS, STRAIGHT OR INDEXED
+  LDA #0
   JSR ADMODEANDLEXPR
   LDY #04  ;ZEROPAGE MODE
   CPX #1
   BEQ +
   LDY #07  ;ABSOLUTE MODE
+  STY INSTRDDRODE
   CMP #CHR
   BNE +
   RTS
+  CMP #","
   BEQ +
-  JMP SYNTAXRROR
+  JSR ADMODEET
   INC INSTRDDRODE
   CPX #0
   BEQ +
   INC INSTRDDRODE
+  CMP #CHR
   BNE -
   RTS

ADMODEMMEDIATE = *
   JSR GETOKEN  ;GET THE "#"
   LDA #1
   JSR ADMODEANDLEXPR
   CMP #CHR
   BEQ +
   JMP SYNTAXRROR
+  LDA #02
   STA INSTRDDRODE
   RTS

ADMODEELATIVE = *
   LDA #2
   JSR ADMODEANDLEXPR
   CMP #CHR
   BEQ +
   JMP SYNTAXRROR
+  LDA #03
   STA INSTRDDRODE
   RTS

ADMODENDIRECT = *
   JSR GETOKEN  ;GET THE "("
   LDA #0
   JSR PARSEXPRESSION
   CMP #","
   BEQ ADMODEND
   CMP #")"
   BEQ +
-  JMP SYNTAXRROR
+  JSR GETOKEN
   LDX TOKENYPE
   CPX #TOKENPECIAL
   BNE -
   LDA TOKENHAR
   CMP #","
   BEQ ADMODEND
   CMP #CHR
   BNE -
   LDA #0
   STA ADMODEUSTE
   JSR ADMODEANDLEXPRN
   LDA #10
   STA INSTRDDRODE
   RTS

   ADMODEND = *
   LDA #1
   STA ADMODEUSTE
   JSR ADMODEANDLEXPRN
   JSR ADMODEET
   CPX #0
   BEQ +
-  JMP SYNTAXRROR
+  CMP #")"
   BNE -
   JSR GETOKEN
   CPX #TOKENPECIAL
   BNE -
   CMP #CHR
   BNE -
   LDA #11
   STA INSTRDDRODE
   RTS

   ADMODEND = *
   LDA #1
   STA ADMODEUSTE
   JSR ADMODEANDLEXPRN
   JSR ADMODEET
   CPX #1
   BEQ +
-  JMP SYNTAXRROR
+  CMP #CHR
   BNE -
   LDA #12
   STA INSTRDDRODE
   RTS

ADMODEET = *  ;( .=TOKENYPE, TOKEN ) : .=SPECIALHAR, .=0:X/1:Y
   JSR GETOKEN
   LDX TOKENYPE
   CPX #TOKENDENTIFIER
   BEQ +
-  JMP SYNTAXRROR
+  LDA STRINGEN
   CMP #1
   BNE -
   LDA STRINGUF+0
   LDY #0
   CMP #"X"
   BEQ +
   INY
   CMP #"Y"
   BNE -
+  TYA
   PHA
   JSR GETOKEN
   LDX TOKENYPE
   CPX #TOKENPECIAL
   BNE -
   PLA
   TAX
   LDA TOKENHAR
   RTS

ADMODEUSTE .BUF 1
ADMODEHAR   .BUF 1
ADMODEOLE   .BUF 1

ADMODEANDLEXPR = *  ;( .=1:BYTE+2:REL, ADDRESS ) : .=NEXTHAR, .=VALYTES,
   STA ADMODEUSTE   ;                               INSTRALUE, INSTRALUEYPE
   LDA #0
   JSR PARSEXPRESSION
   STA ADMODEHAR

   ADMODEANDLEXPRN = *
   JSR EVALUATEXPRESSION
   LDA IDAL+0
   LDY IDAL+1
   STA INSTRALUE+0
   STY INSTRALUE+1
   LDA IDYPE
   STA INSTRALUEYPE
   BCS ADMODEXPROLE
   LDA IDAL+2
   ORA IDAL+3
   BEQ +
-  LDA #ERRALUEOOARGE
   JMP ERROR
+  LDA ADMODEUSTE
   BNE ++
   LDX #2
   LDA INSTRALUE+1
   BNE +
-  LDX #1
+  LDA ADMODEHAR
   RTS
+  CMP #1  ;MUST BE BYTE
   BNE +
   LDA INSTRALUE+1
   BNE --
   BEQ -
+  CLC     ;MUST BE RELATIVE
   LDA ADDRESS+0
   ADC #2
   STA WORK+14
   LDA ADDRESS+1
   ADC #0
   STA WORK+15
   SEC
   LDA INSTRALUE+0
   SBC WORK+14
   STA INSTRALUE+0
   TAX
   LDA INSTRALUE+1
   SBC WORK+15
   STA INSTRALUE+1
   CMP #0
   BNE +
   CPX #128
   BCC ++
-  LDA #ERRRANCHOOAR
   JMP ERROR
+  CMP #$FF
   BNE -
   CPX #128
   BCC -
+  LDA #0
   STA INSTRALUE+1
   LDX #1
   LDA ADMODEHAR
   RTS

   ADMODEXPROLE = *
   ;** GET PRESUMED HOLE TYPE
   LDA #$02    ;HOLEYPE=WORD
   LDX ADMODEUSTE
   BEQ +
   LDA #$01    ;HOLEYPE=BYTE
   CPX #1
   BEQ +
   LDA #$40      ;HOLEYPE=BRANCH
   ;** CHECK FOR SPECIAL CASES OF "STX ZP,Y" AND "STY ZP,X" WHICH MUST BE ZP
+  CMP #$02
   BNE +
   LDX INSTRUM
   CPX #49       ;INSTR.49==STX
   BCC +
   CPX #50+1     ;INSTR.50==STY
   BCS +
   LDX ADMODEHAR
   CPX #","
   BNE +
   LDA #$01      ;IS ONE OF SPECIALS, SO HOLE MUST BE 8-BITS
   ;** RECORD THE HOLE
+  PHA
   TAX
   LDA #1
   JSR ADDEMORYOLE
   ;** GET THE RETURN VALUES
   PLA
   CMP #$40
   BNE +
   LDA #1
+  TAX
   LDY #$80
   STY INSTRALUEYPE
   LDY #$00
   STY INSTRALUE+0
   STY INSTRALUE+1
   LDA ADMODEHAR
   RTS

;TAKEN FROM IGHTY ON 4.0: INSTR# + ADDRODE -> OPCODE CONVERSION + LENGTH

OPCODEASE      = WORK+14
OPCODEDMODEUM = WORK+15

INSTRETPCODE = *  ;( .=INSTR#, .=ADDRODE ) : INSTRPCODE, INSTREN, .=INV
   TAY                          ;.$DA4B  [A8      ]  TAY
   LDA OPCODEASEAB,Y          ;.$DA4C  [B9 55 C2]  LDA $C255,Y
   STA OPCODEASE               ;.$DA4F  [85 48   ]  STA $48
   STX OPCODEDMODEUM          ;.$DA51  [86 49   ]  STX $49
   LDA OPCODEDMODEAB,Y        ;.$DA53  [B9 8D C2]  LDA $C28D,Y
   BMI ++                       ;.$DA56  [30 0E   ]  BMI $DA66
   CMP OPCODEDMODEUM          ;.$DA58  [C5 49   ]  CMP $49
   BNE +                        ;.$DA5A  [D0 08   ]  BNE $DA64
   LDA OPCODEENAB,X           ;.$DA5C  [BD 6C C3]  LDA $C36C,X
   TAX                          ;.$DA5F  [AA      ]  TAX
   LDA OPCODEASE               ;.$DA60  [A5 48   ]  LDA $48
   STA INSTRPCODE              ;
   STX INSTREN                 ;
   CLC                          ;.$DA62  [18      ]  CLC
   RTS                          ;.$DA63  [60      ]  RTS
+  NOP                          ;
-  SEC                          ;.$DA64  [38      ]  SEC
   RTS                          ;.$DA65  [60      ]  RTS
                                ;
+  AND #$7F                     ;.$DA66  [29 7F   ]  AND #$7F
   TAY                          ;.$DA68  [A8      ]  TAY
   LDA OPCODERFFAB,Y         ;.$DA69  [B9 60 C3]  LDA $C360,Y
   CLC                          ;.$DA6C  [18      ]  CLC
   ADC OPCODEDMODEUM          ;.$DA6D  [65 49   ]  ADC $49
   TAY                          ;.$DA6F  [A8      ]  TAY
   DEY                          ; <THE AD MODES START FROM 1 NOT 0 LIKE IN MM4>
   LDA OPCODERASKAB,Y        ;.$DA70  [B9 D2 C2]  LDA $C2D2,Y
   BMI -                        ;.$DA73  [30 EF   ]  BMI $DA64
   ORA OPCODEASE               ;.$DA75  [05 48   ]  ORA $48
   TAY                          ;.$DA77  [A8      ]  TAY
   LDA OPCODEENAB,X           ;.$DA78  [BD 6C C3]  LDA $C36C,X
   TAX                          ;.$DA7B  [AA      ]  TAX
   TYA                          ;.$DA7C  [98      ]  TYA
   STA INSTRPCODE              ;
   STX INSTREN                 ;
   CLC                          ;.$DA7D  [18      ]  CLC
   RTS                          ;.$DA7E  [60      ]  RTS

OPCODEASEAB = *
   .BYTE $00,$61,$21,$02,$90,$B0,$F0,$24,$30,$D0,$10,$00,$50,$70,$18,$D8
   .BYTE $58,$B8,$C1,$E0,$C0,$C6,$CA,$88,$41,$E6,$E8,$C8,$4C,$20,$A1,$A2
   .BYTE $A0,$42,$EA,$01,$48,$08,$68,$28,$22,$62,$40,$60,$E1,$38,$F8,$78
   .BYTE $81,$86,$84,$AA,$A8,$BA,$8A,$9A,$98

OPCODEDMODEAB = *
   .BYTE $00,$81,$81,$82,$03,$03,$03,$83,$03,$03,$03,$01,$03,$03,$01,$01
   .BYTE $01,$01,$81,$84,$84,$85,$01,$01,$81,$85,$01,$01,$86,$07,$81,$87
   .BYTE $88,$82,$01,$81,$01,$01,$01,$01,$82,$82,$01,$01,$81,$01,$01,$01
   .BYTE $89,$8A,$8B,$01,$01,$01,$01,$01,$01

OPCODEENAB = *
   .BYTE $00,$01,$02,$02,$02,$02,$02,$03,$03,$03,$03,$02,$02

OPCODERFFAB = *
   .BYTE 0,0,12,24,36,48,60,72,84,96,108,120

OPCODERASKAB = *
   ;      01  02  03  04  05  06  07  08  09  10  11  12 : ADDRODE
   ;      --  --  --  --  --  --  --  --  --  --  --  --     <IF COMPRESSED>
   .BYTE $80,$08,$80,$04,$14,$80,$0C,$1C,$18,$80,$00,$10  ;[TRIM:1+0=1] [ADD=2]
   .BYTE $08,$80,$80,$04,$14,$80,$0C,$1C,$80,$80,$80,$80  ;[TRIM:0+4=4] [ADD=2]
   .BYTE $80,$80,$80,$04,$80,$80,$0C,$80,$80,$80,$80,$80  ;[TRIM:3+5=8] [ADD=2]
   .BYTE $80,$00,$80,$04,$80,$80,$0C,$80,$80,$80,$80,$80  ;[TRIM:1+5=6] [ADD=2]
   .BYTE $80,$80,$80,$04,$14,$80,$0C,$1C,$80,$80,$80,$80  ;[TRIM:3+4=7] [ADD=2]
   .BYTE $80,$80,$80,$80,$80,$80,$00,$80,$80,$20,$80,$80  ;[TRIM:6+2=8] [ADD=2]
   .BYTE $80,$00,$80,$04,$80,$14,$0C,$80,$1C,$80,$80,$80  ;[TRIM:1+3=4] [ADD=2]
   .BYTE $80,$00,$80,$04,$14,$80,$0C,$1C,$80,$80,$80,$80  ;[TRIM:1+4=5] [ADD=2]
   .BYTE $80,$80,$80,$04,$14,$80,$0C,$1C,$18,$80,$00,$10  ;[TRIM:3+0=3] [ADD=2]
   .BYTE $80,$80,$80,$04,$80,$14,$0C,$80,$80,$80,$80,$80  ;[TRIM:3+5=8] [ADD=2]
   .BYTE $80,$80,$80,$04,$14,$80,$0C,$80,$80,$80,$80,$80  ;[TRIM:3+5=8] [ADD=2]

;======== EXPRESSION HANDLING ========

PARSEXPRYPE .BUF 1

PARSEXPRESSION = *  ;( .=TYPE(0=NUM,1=EITHER) ) : .=NEXTPECIALHAR,.=TYPE
   STA PARSEXPRYPE
   LDX #16
   STX EXPFFSET
   LDA #"+"
   STA EXPP+0,X
   LDX #3
-  LDA #0
   STA EXPOLEYPE,X
   LDA #ACEEMULL
   STA EXPOLEDDR,X
   LDA SOURCEINE,X
   STA EXPRCINE,X
   LDA FILETR,X
   STA EXPRCILE,X
   DEX
   BPL -
   LDA SOURCEOL
   STA EXPRCOL
   BIT DEBUG
   BPL EXPETPERAND
   LDA #<PARSEXPRSG
   LDY #>PARSEXPRSG
   JSR PUTS

   ;** EXPECTING OPERAND
   EXPETPERAND = *
   LDA #0
   STA EXPLUSOUNT
   STA EXPINUSOUNT
   STA EXPESSOUNT
   STA EXPREATEROUNT
   EXPETPERANDONT = *
   LDX EXPFFSET
   LDA #0
   STA EXPESERVED,X
   JSR GETOKEN
   CPX #TOKENPECIAL
   BNE EXPOTPECIAL
   LDA TOKENHAR
   CMP #"+"
   BNE +
   INC EXPLUSOUNT
   JMP EXPETPERANDONT
+  CMP #"-"
   BNE +
   INC EXPINUSOUNT
   JMP EXPETPERANDONT
+  CMP #">"
   BNE +
   INC EXPREATEROUNT
   JMP EXPETPERANDONT
+  CMP #"<"
   BNE +
   INC EXPESSOUNT
   JMP EXPETPERANDONT
+  CMP #"*"
   BNE +
   JMP EXPPNTAR
+  JMP EXPPNELATIVE

   EXPOTPECIAL = *
   LDX EXPFFSET
   LDA EXPINUSOUNT
   AND #$01
   LSR
   ROR
   STA EXPIGN,X
   JSR EXPIGUREIO
   STA EXPIO,X
   LDA #$00
   STA EXPYPE,X
   LDX TOKENYPE
   CPX #TOKENDENTIFIER
   BNE +
   LDA #0
   JMP EXPPNDENTIFIER
+  CPX #TOKENUMBER
   BNE +
   JMP EXPPNUMBER
+  CPX #TOKENTRING
   BNE +
   JMP EXPPNTRING
+  JMP SYNTAXRROR
   PARSEXPRSG = *
   .ASC "...MUST PARSE AN EXPRESSION..."
   .BYTE CHR,0

;"STEROIDS DO NOT CONCERN ME, DMIRAL.   WANT THAT SHIP, NOT EXCUSES!"
;"UDHOLE!?  LIMY!!?  Y HOME, THIS IS!"

EXPIGUREIOORK .BUF 1

EXPIGUREIO = * ; ( ) : .=IO_VALUE ;.:UNCHANGED
   LDA EXPREATEROUNT
   CMP #16
   BCC +
   LDA #15
+  ASL
   ASL
   ASL
   ASL
   STA EXPIGUREIOORK
   LDA EXPESSOUNT
   CMP #2
   BCC +
   LDA #1
+  ORA EXPIGUREIOORK
   RTS

EXPPNELXIT .BUF 1  ;WHETHER TO EXIT EXP AFTER RELATIVE REF.

EXPPNELATIVE = *
   LDX #0
   CMP #":"
   BEQ +
   LDX #$FF
+  STX EXPPNELXIT
   LDA EXPLUSOUNT  ;THERE MUST BE SOME PLUSES OR MINUSES
   ORA EXPINUSOUNT
   BNE +
   JMP SYNTAXRROR
+  JSR EXPIGUREIO
   LDX EXPFFSET
   STA EXPIO,X
   LDA #0
   STA EXPIGN,X
   LDA #"+"
   LDY EXPLUSOUNT
   BEQ +
   LDX EXPINUSOUNT
   BEQ ++
   JMP SYNTAXRROR
+  LDA #"-"
   LDY EXPINUSOUNT
   BNE +
   JMP SYNTAXRROR
+  DEY
   JSR GENELABEL
   LDA EXPPNELXIT
   ;** FALL THROUGH

EXPPNDENTIFIER = *
   PHA
   JSR FINDYMBOL
   LDX EXPFFSET
   LDA IDYPE
   CMP #$81
   BCC +
   CMP #$FF
   BEQ +
   LDA #ERRONUMDXPR
   JMP ERROR
+  STA EXPYPE,X
   LDY #0
   CMP #$80
   BCS +
-  LDA IDAL,Y
   STA EXPALUE,X
   INX
   INY
   CPY #4
   BCC -
   PLA
   JMP EXPETPERATOR
+  INC EXPNRESNT
-  LDA IDTR,Y
   STA EXPALUE,X
   INX
   INY
   CPY #4
   BCC -
   PLA
   JMP EXPETPERATOR

EXPPNTAR = *
   BIT ORIGINET
   BMI +
   LDA #ERRRIGINOTET
   JMP ERROR
+  LDX EXPFFSET
   LDA EXPINUSOUNT
   AND #$01
   LSR
   ROR
   STA EXPIGN,X
   JSR EXPIGUREIO
   STA EXPIO,X
   LDA #$01
   STA EXPYPE,X
   LDA ADDRESS+0
   STA EXPALUE+0,X
   LDA ADDRESS+1
   STA EXPALUE+1,X
   LDA #0
   STA EXPALUE+2,X
   STA EXPALUE+3,X
   LDA #0
   JMP EXPETPERATOR

EXPPNUMBER = *
   LDX EXPFFSET
   LDA #$00
   STA EXPYPE,X
   LDY #0
-  LDA NUMBER,Y
   STA EXPALUE,X
   INX
   INY
   CPY #4
   BCC -
   LDA #0
   JMP EXPETPERATOR

EXPPNTRING = *
   LDA STRINGEN
   CMP #1
   BNE +
   ;** INTERPRET STRING AS NUMBER
   LDX EXPFFSET
   LDA #$00
   STA EXPYPE,X
   LDA STRINGUF+0
   STA EXPALUE+0,X
   LDA #0
   STA EXPALUE+1,X
   STA EXPALUE+2,X
   STA EXPALUE+3,X
   LDA #0
   JMP EXPETPERATOR

   ;** INTERPRET STRING AS ACTUAL STRING
+  LDA EXPLUSOUNT
   ORA EXPINUSOUNT
   ORA EXPESSOUNT
   ORA EXPREATEROUNT
   BEQ +
-  LDA #ERRNVALTRPERS
   JMP ERROR
+  LDA EXPFFSET
   CMP #16
   BNE -
   LDA PARSEXPRYPE
   BNE +
-  JMP SYNTAXRROR
+  JSR GETOKEN
   CPX #TOKENPECIAL
   BNE -
+  LDX #$80
   RTS

EXPETPERATOR = *  ;(.=EXITLAG)
   PHA
   CLC
   LDA EXPFFSET
   ADC #14
   STA EXPFFSET
   BCC +
   LDA #ERROOANYPERANDS
   JMP ERROR
+  PLA
   CMP #0
   BEQ +
-  LDX EXPFFSET
   TXA
   STA EXPENGTH
   LDA SOURCEOL
   STA EXPRCOL
   LDA TOKENHAR
   LDX #0
   RTS
+  JSR GETOKEN
   LDX TOKENYPE
   CPX #TOKENPECIAL
   BEQ +
   JMP SYNTAXRROR
+  LDA TOKENHAR
   CMP #"+"
   BEQ +
   CMP #"-"
   BNE -
+  LDX EXPFFSET
   STA EXPP,X
   JMP EXPETPERAND

EVALUATEXPRESSION = *  ;( EXPABLE ) : .=UNRESOLVED, IDAL, IDYPE
   LDX #3
   LDA #0
-  STA IDAL,X
   DEX
   BPL -
   STA IDYPE
   LDA EXPNRESNT
   BEQ +
   LDA #$80
   STA IDYPE
   SEC
   RTS
 + LDX #16
   STX EXPFFSET

   EVALEXT = *
   LDX EXPFFSET
   LDA EXPYPE,X
   EOR IDYPE    ;(+-:VAL+VAL=VAL,ADR+VAL=ADR,VAL+ADR=ADR,ADR+ADR=VAL)
   STA IDYPE
   LDY #$00
-  LDA EXPALUE,X
   STA NUMBER,Y
   INX
   INY
   CPY #4
   BCC -
   LDX EXPFFSET
   LDA EXPIGN,X
   BPL +
   JSR EVALEGATE
+  LDX EXPFFSET
   CPX #16
   BEQ +
   LDA EXPIO,X
   BEQ +
   JSR EVALIO
+  LDX EXPFFSET
   LDA EXPP,X
   CMP #"+"
   BEQ +
   JSR EVALEGATE
   ;** PERFORM ADDITION
+  CLC
   LDY #4
   LDX #0
-  LDA IDAL,X
   ADC NUMBER,X
   STA IDAL,X
   INX
   DEY
   BNE -
   ;** GO ONTO NEXT OPERATION
   CLC
   LDA EXPFFSET
   ADC #14
   STA EXPFFSET
   CMP EXPENGTH
   BCC EVALEXT
   ;** CHECK GLOBAL HI-LO
   LDA EXPIO+16
   BEQ +
   LDX #3
-  LDA IDAL,X
   STA NUMBER,X
   DEX
   BPL -
   LDA EXPIO+16
   JSR EVALIO
   LDX #3
-  LDA NUMBER,X
   STA IDAL,X
   DEX
   BPL -
+  CLC
   BIT DEBUG
   BMI +
   RTS
+  LDA #<EVALSG
   LDY #>EVALSG
   JSR PUTS
   LDX #IDAL
   JSR PUTNUM
   LDA #","
   JSR PUTCHAR
   LDA #" "
   JSR PUTCHAR
   LDA #"V"
   LDX IDYPE
   BEQ +
   LDA #"A"
+  JSR PUTCHAR
   LDA #CHR
   JSR PUTCHAR
   CLC
   RTS
   EVALSG = *
   .ASC "EVALUATE: RESULT="
   .BYTE 0

EVALEGATE = *  ;( NUMBER ) : -NUMBER
   SEC
   LDY #4
   LDX #0
-  LDA #0
   SBC NUMBER,X
   STA NUMBER,X
   INX
   DEY
   BNE -
   RTS

EVALIONT .BUF 1

EVALIO = *
   ;VALUE $10 WILL EXTRACT HIGH BYTE OF ADDR, $01 WILL EXTRACT LOW BYTE
   PHA
   LSR
   LSR
   LSR
   LSR
   TAX
   BEQ +
-  LDA NUMBER+1
   STA NUMBER+0
   LDA NUMBER+2
   STA NUMBER+1
   LDA NUMBER+3
   STA NUMBER+2
   LDA #$00
   STA NUMBER+3
   DEX
   BNE -
+  PLA
   AND #$0F
   BEQ +
   LDX #0
   STX NUMBER+3
   STX NUMBER+2
   STX NUMBER+1
+  RTS

;======== SYMBOL TABLE MANAGEMENT ========

FINDYMBOL = *  ;( STRINGUF, STRINGEN ) : .=CODE,IDTR,IDAL
   ;** RET: CODE .=(SYMOUND,SYMNRESOLVED,SYMEW)
   JSR HASH
   LDY #3
-  LDA (HASHTR),Y
   STA MP,Y
   DEY
   BPL -
   FINDYMEXT = *
   LDA MP+3
   CMP #ACEEMULL
   BNE +
   JMP FINDYMREATE
+  LDA #<SYMUF
   LDY #>SYMUF
   STA ZP+0
   STY ZP+1
   LDA #12+8+1
   LDY #0
   JSR FETCH
   LDA SYMAMEEN
   CMP STRINGEN
   BNE FINDYMONT
   CMP #8+1
   BCC +
   CLC
   ADC #12+1
   LDY #0
   JSR FETCH
+  LDX #0
-  LDA STRINGUF,X
   BEQ +
   CMP SYMAME,X
   BNE FINDYMONT
   INX
   BNE -
+  LDX #3
-  LDA MP,X
   STA IDTR,X
   LDA SYMALUE,X
   STA IDAL,X
   DEX
   BPL -
   LDA SYMYPE
   STA IDYPE
   LDA #SYMOUND
   BIT SYMYPE
   BPL +
   LDA #SYMNRESOLVED
+  RTS

   FINDYMONT = *
   LDX #3
-  LDA SYMEXT,X
   STA MP,X
   DEX
   BPL -
   JMP FINDYMEXT

FINDYMREATE = *
   LDA #$80
   STA SYMYPE
   STA IDYPE
   LDA #$00
   STA SYMLASS
   STA SYMNRESPND
   LDA STRINGEN
   STA SYMAMEEN
   LDX #0
-  LDA STRINGUF,X
   STA SYMAME,X
   BEQ +
   INX
   BNE -
+  CLC
   LDA #12+1
   ADC SYMAMEEN
   LDY #0
   JSR MALLOC
   BCC +
   LDA #ERRNSUFFICIENTEMORY
   JMP ERROR
+  LDY #3
-  LDA #ACEEMULL
   STA SYMALUE,Y
   LDA #0
   STA IDAL,Y
   LDA (HASHTR),Y
   STA SYMEXT,Y
   LDA MP,Y
   STA IDTR,Y
   STA (HASHTR),Y
   DEY
   BPL -
   JSR STASHYMBOL
   LDA #SYMEW
   RTS

FETCHYMBOL = *  ;( [MP] ) : SYMUF
   LDA #<SYMUF
   LDY #>SYMUF
   STA ZP+0
   STY ZP+1
   LDA #12+8+1
   LDY #0
   JSR FETCH
   LDA SYMAMEEN
   CMP #8+1
   BCC +
   CLC
   ADC #12+1
   LDY #0
   JSR FETCH
+  RTS

FETCHYMBOLEADER = *  ;( [MP] ) : SYMUF (HEADER)
   LDA #<SYMUF
   LDY #>SYMUF
   STA ZP+0
   STY ZP+1
   LDA #12
   LDY #0
   JSR FETCH
   RTS

STASHYMBOL = *  ;( SYMUF, [MP] )
   LDA #<SYMUF
   LDY #>SYMUF
   STA ZP+0
   STY ZP+1
   CLC
   LDA #12+1
   ADC SYMAMEEN
   LDY #0
   JSR STASH
   RTS

STASHYMBOLEADER = *  ;( SYMUF(HEADER), [MP] )
   LDA #<SYMUF
   LDY #>SYMUF
   STA ZP+0
   STY ZP+1
   LDA #12
   LDY #0
   JSR STASH
   RTS

INITYMBOLABLE = *
   LDA #<IDENTASHABLE
   LDY #>IDENTASHABLE
   LDX #HASHABLEAGES
   ;** FALL THROUGH

FILLULL = *
   STA WORK+0
   STY WORK+1
   LDY #0
   LDA #ACEEMULL
-  STA (WORK),Y
   INY
   BNE -
   INC WORK+1
   DEX
   BNE -
   RTS

FINDNRESYMBOL = *
   ;** FETCHES SYMBOL AND REFERENCE
   LDA #$80
   STA DUMPYMPT
   JMP DUMPYMBOLABLEN
   FOUNDNRESYMBOL = *
   LDX #3
-  LDA SYMALUE,X
   STA EXPTR,X
   DEX
   BPL -
   JSR FETCHXP
   RTS

DUMPYMNTRIES .BUF 2
DUMPYMPT .BUF 1
DUMPOUNT = IDAL

DUMPYMBOLABLE = *
   LDA #$00
   STA DUMPYMPT
   LDX #3
-  STA DUMPOUNT,X
   DEX
   BPL -
   BIT SYMUMP
   BMI +
   RTS
+  LDA #<DUMPYMSG1
   LDY #>DUMPYMSG1
   JSR PUTS
  DUMPYMBOLABLEN  = *
   LDA #<IDENTASHABLE
   LDY #>IDENTASHABLE
   STA HASHTR+0
   STY HASHTR+1
   LDA #0
   LDY #HASHABLENTRIESIGH
   STA DUMPYMNTRIES+0
   STY DUMPYMNTRIES+1
-  JSR DUMPYMUCKET
   CLC
   LDA HASHTR+0
   ADC #4
   STA HASHTR+0
   BCC +
   INC HASHTR+1
+  INC DUMPYMNTRIES+0
   BNE -
   DEC DUMPYMNTRIES+1
   BNE -
   LDA #<DUMPYMSG2
   LDY #>DUMPYMSG2
   JSR PUTS
   LDX #DUMPOUNT
   JSR PUTNUM
   LDA #CHR
   JSR PUTCHAR
   RTS

   DUMPYMUCKET = *
   LDY #3
-  LDA (HASHTR),Y
   STA MP,Y
   DEY
   BPL -
-  LDA MP+3
   CMP #ACEEMULL
   BNE +
   RTS
+  JSR FETCHYMBOL
   JSR DUMPYMBOL
   LDX #3
-  LDA SYMEXT,X
   STA MP,X
   DEX
   BPL -
   JMP --

   DUMPYMBOL = *
   BIT DUMPYMPT
   BPL ++
   LDA SYMYPE
   CMP #$80
   BEQ +
   CMP #$FF
   BNE ++
+  PLA ;** POP CALL FROM DUMPYMUCKET
   PLA
   PLA ;** POP CALL FROM DUMPYMBOLABLE
   PLA
   JMP FOUNDNRESYMBOL
+  LDX #DUMPOUNT
   JSR INCONG
   LDA #0
   STA NUMBER+2
   STA NUMBER+3
   SEC
   LDA HASHTR+0
   SBC #<IDENTASHABLE
   STA NUMBER+0
   LDA HASHTR+1
   SBC #>IDENTASHABLE
   STA NUMBER+1
   LSR NUMBER+1
   ROR NUMBER+0
   LSR NUMBER+1
   ROR NUMBER+0
   LDX #NUMBER
   LDY #4
   JSR WPUTNUM
   LDA #2
   JSR SPACE
   LDX #3
-  LDA SYMALUE,X
   STA NUMBER,X
   DEX
   BPL -
   LDA NUMBER+3
   JSR PUTHEX
   LDA NUMBER+2
   JSR PUTHEX
   LDA NUMBER+1
   JSR PUTHEX
   LDA NUMBER+0
   JSR PUTHEX
   LDA #1
   JSR SPACE
   LDX #NUMBER
   LDY #10
   JSR WPUTNUM
   LDA #2
   JSR SPACE
   LDA #"V"
   LDX SYMYPE
   BEQ +
   LDA #"A"
   BIT SYMYPE
   BPL +
   LDA #"?"
+  JSR PUTCHAR
   LDA #2
   JSR SPACE
   LDA #<SYMAME
   LDY #>SYMAME
   JSR PUTS
   LDA #CHR
   JSR PUTCHAR
   JSR CHECKTOP
   RTS

   SPACEOUNT .BUF 1

   SPACE = *
   STA SPACEOUNT
-  LDA #" "
   JSR PUTCHAR
   DEC SPACEOUNT
   BNE -
   RTS

   DUMPYMSG1 = *
   .ASC "          "
   .BYTE CHR
   .ASC "----  -------- ----------  -  -----"
   .BYTE CHR,0
   DUMPYMSG2 = *
   .ASC "--"
   .BYTE CHR
   .ASC "UMBER OF SYMBOLS: "
   .BYTE 0
;1234567890123456789012345678901234567890

HASHORK .BUF 2

HASH = *
   LDA #$AA
   STA HASHAL+0
   STA HASHAL+1
   LDX #0
-  LDA STRINGUF,X
   BNE +
   LDA HASHAL+0
   STA HASHTR+0
   LDA HASHAL+1
   AND #HASHABLEASK
   ASL HASHTR+0
   ROL
   ASL HASHTR+0
   ROL
   STA HASHTR+1
   CLC
   LDA HASHTR+0
   ADC #<IDENTASHABLE
   STA HASHTR+0
   LDA HASHTR+1
   ADC #>IDENTASHABLE
   STA HASHTR+1
   RTS
   ;** HASHAL := HASHAL * 37;
+  LDA HASHAL+0
   LDY HASHAL+1
   STA HASHORK+0
   STY HASHORK+1
   ASL              ;TIMES 2
   ROL HASHAL+1
   ASL              ;TIMES 4
   ROL HASHAL+1
   ASL              ;TIMES 8
   ROL HASHAL+1
   JSR HASHDDORK  ;TIMES 9
   ASL              ;TIMES 18
   ROL HASHAL+1
   ASL              ;TIMES 36
   ROL HASHAL+1
   JSR HASHDDORK  ;TIMES 37
   ADC STRINGUF,X
   STA HASHAL+0
   BCC +
   INC HASHAL+1
+  INX
   BNE -

HASHDDORK = *
   CLC
   ADC HASHORK+0
   STA HASHAL+0
   LDA HASHAL+1
   ADC HASHORK+1
   STA HASHAL+1
   LDA HASHAL+0
   RTS

;======== SYMBOLS, EXPRESSIONS, AND HOLES: SYMBOL DEFINITION SUPPORT ========

PARSEEFINEAR = *
   JSR FINDYMBOL
   CMP #SYMEW
   BEQ +
   LDA SYMYPE
   CMP #$80
   BEQ +
   LDA #ERREDEFINEDYMBOL
   JMP ERROR
+  LDA #$FF
   STA SYMYPE
   JSR STASHYMBOL
   LDX #3
-  LDA IDTR,X
   STA VARTR,X
   DEX
   BPL -
   RTS

ADDEMORYOLE = *  ;( .=HOLEYPE, ADDRESS+. )
   ;** PUT IN HOLE INFORMATION
   STX EXPOLEYPE
   CLC
   ADC ADDRESS+0
   STA EXPOLEDDR+0
   LDA ADDRESS+1
   ADC #0
   STA EXPOLEDDR+1
   LDA #0
   STA EXPOLEDDR+2
   STA EXPOLEDDR+3
   JMP ADDOLEN

ADDARIABLEOLE = *  ;( VARTR, EXPABLE ) : ...
   ;** PUT IN HOLE INFORMATION
   LDA #$80
   STA EXPOLEYPE
   LDX #3
-  LDA VARTR,X
   STA EXPOLEDDR,X
   DEX
   BPL -

   ADDOLEN = *
   ;** KEEP A COUNT OF THE GLOBAL NUMBER OF UNRESOLVED REFERENCES
   LDX #HOLEOUNT
   JSR INCONG
   ;** KEEP A SEPARATE COUNT OF THE UNRESOLVED RELATIVE LABELS:THEY MUST BE RESD
   LDA STRINGEN
   CMP #2
   BCC +
   LDA STRINGUF+1
   CMP #"+"
   BEQ +
   CMP #"-"
   BNE ++
+  LDX #RELOLEOUNT
   JSR INCONG
   ;** ALLOCATE STORAGE FOR EXPRESSION DESCRIPTOR
+  LDA EXPENGTH
   LDY #0
   JSR MALLOC
   BCC +
   LDA #ERRNSUFFICIENTEMORY
   JMP ERROR
+  LDX #3
-  LDA MP,X
   STA EXPTR,X
   DEX
   BPL -
   ;** SCAN FOR POINTERS TO UNRESOLVED LABELS, REFS INTO CORRESP.REFERENCE LISTS
   LDX #16
   STX EXPFFSET

   ADDOLEEXT = *
   LDX EXPFFSET
   LDA EXPYPE,X
   BPL ADDOLEONT
   LDY #0
-  LDA EXPALUE,X
   STA MP,Y
   INX
   INY
   CPY #4
   BCC -
   JSR FETCHYMBOLEADER
   LDX EXPFFSET
   LDY #0
-  LDA SYMALUE,Y
   STA EXPEXTNRES,X
   LDA EXPTR,Y
   STA SYMALUE,Y
   INX
   INY
   CPY #4
   BCC -
   LDX EXPFFSET
   LDA SYMNRESPND
   STA EXPEXTPND,X
   STX SYMNRESPND
   JSR STASHYMBOLEADER

   ADDOLEONT = *
   CLC
   LDA EXPFFSET
   ADC #14
   STA EXPFFSET
   CMP EXPENGTH
   BCC ADDOLEEXT

   ;** STORE EXPRESSION DESCRIPTOR
   JMP STASHXP

PLUGTACKEAD .BUF 4
PLUGECUF    = *
PLUGECEXT   .BUF 4
PLUGECARTR .BUF 4
PLUGECDAL  .BUF 4
PLUGECDYPE .BUF 1

PLUGTACKNIT = *
   LDA #ACEEMULL
   STA PLUGTACKEAD+3
   RTS

PLUGTACKUSH = *  ;( VARTR, IDAL, IDYPE )
   LDA #13
   LDY #0
   JSR MALLOC
   BCC +
   LDA #ERRNSUFFICIENTEMORY
   JSR ERROR
+  LDX #3
-  LDA PLUGTACKEAD,X
   STA PLUGECEXT,X
   LDA MP,X
   STA PLUGTACKEAD,X
   LDA VARTR,X
   STA PLUGECARTR,X
   LDA IDAL,X
   STA PLUGECDAL,X
   DEX
   BPL -
   LDA IDYPE
   STA PLUGECDYPE
   LDA #<PLUGECUF
   LDY #>PLUGECUF
   STA ZP+0
   STY ZP+1
   LDA #13
   LDY #0
   JSR STASH
   RTS

PLUGTACKOP = *  ;( ) : VARTR, IDAL, IDYPE, .=EMPTY
   LDX #3
-  LDA PLUGTACKEAD,X
   STA MP,X
   DEX
   BPL -
   LDA MP+3
   CMP #ACEEMULL
   BNE +
   SEC
   RTS
+  LDA #<PLUGECUF
   LDY #>PLUGECUF
   STA ZP+0
   STY ZP+1
   LDA #13
   LDY #0
   JSR FETCH
   LDA #13
   LDY #0
   JSR FREE
   LDX #3
-  LDA PLUGECEXT,X
   STA PLUGTACKEAD,X
   LDA PLUGECARTR,X
   STA VARTR,X
   LDA PLUGECDAL,X
   STA IDAL,X
   DEX
   BPL -
   LDA PLUGECDYPE
   STA IDYPE
   RTS

ASSIGNARAVE .BUF 10

ASSIGNARIABLE = *  ;( VARTR, IDAL, IDYPE ) : ... ;CHANGES IDTR,VARTR,ETC.
   JSR PLUGTACKNIT
   ;** ASSIGN VALUE TO VARIABLE
   ASSIGNARODY = *
   LDX #3
-  LDA VARTR,X
   STA MP,X
   DEX
   BPL -
   JSR FETCHYMBOLEADER
   LDA SYMYPE
   CMP #$FF
   BEQ +
   LDA #ERRNTERNSSIGN
   JMP ERROR
+  LDX #3
-  LDA SYMALUE,X
   STA EXPTR,X
   LDA IDAL,X
   STA SYMALUE,X
   DEX
   BPL -
   LDA SYMNRESPND
   STA EXPFFSET
   LDA IDYPE
   STA SYMYPE
   JSR STASHYMBOLEADER

   ;** CASCADE CHANGES IF NECESSARY
   ;UN THROUGH REFERENCE LIST, FILLING IN VALUE OF ID, UNLINKING FROM THIS ID.
   ;F WE RESOLVE AN EXPRESSION, EVALUATE IT, AND IF THE HOLE IS IN MEMORY, FILL
   ;IT.  F THE FILLED HOLE IS ANOTHER VARIABLE, PUSH THE <VARTR,IDAL,IDYPE>
   ;VALUES ONTO THE PLUG STACK AND CONTINUE WITH REFERENCE LIST FOR THE CURRENT
   ;VARIABLE.  HEN WE ARE DONE WITH THE CURRENT LABEL, POP A VARIABLE OFF THE
   ;PLUG STACK AND CONTINUE WITH IT.  THERWISE, EXIT.
   ASSIGNARASCADE = *
   LDA EXPTR+3
   CMP #ACEEMULL
   BNE +
   JSR PLUGTACKOP
   BCC ASSIGNARODY
   RTS
   ;** FETCH UNRESOLVED EXPRESSION
+  JSR FETCHXP
   ;** FILL IN VALUE
   LDX EXPFFSET
   LDA IDYPE
   STA EXPYPE,X
   LDY #0
-  LDA IDAL,Y
   STA EXPALUE,X
   INX
   INY
   CPY #4
   BCC -
   DEC EXPNRESNT
   BNE ASSIGNARNRESOLVED
   JMP ASSIGNARESOLVED

   ;** STILL UNRESOLVED--STASH MODIFIED EXPRESSION
   ASSIGNARNRESOLVED = *
   JSR STASHXP
   JMP ASSIGNARASCADEONT

   ;** RESOLVED--EVALUATE EXPRESSION, FILL IN HOLE
   ASSIGNARESOLVED = *
   LDX #3
-  LDA EXPTR,X
   STA MP,X
   DEX
   BPL -
   LDA EXPENGTH
   LDY #0
   JSR FREE
   ;** SAVE VARTR,IDAL,IDYPE,EXPFFSET
   LDX #3
-  LDA VARTR,X
   STA ASSIGNARAVE+0,X
   LDA EXPOLEDDR,X
   STA VARTR,X
   LDA IDAL,X
   STA ASSIGNARAVE+4,X
   DEX
   BPL -
   LDA IDYPE
   STA ASSIGNARAVE+8
   LDA EXPFFSET
   STA ASSIGNARAVE+9
   LDX #HOLEOUNT
   JSR DECONG
   LDA SYMLASS
   CMP #$01
   BEQ +
   LDX #RELOLEOUNT
   JSR DECONG
   ;** EVALUATE NEW EXPRESSION
+  JSR EVALUATEXPRESSION
   ;** FILL HOLE--ID HOLE: PUSH HOLE PLUG--DO SOMETHING ELSE FOR MEMORY HOLE
   LDA EXPOLEYPE
   CMP #$80
   BEQ +
   JSR FILLEMORYOLE
   JMP ++
+  JSR PLUGTACKUSH
   ;** RESTORE VARTR,IDAL,IDYPE,EXPFFSET
+  LDX #3
-  LDA ASSIGNARAVE+0,X
   STA VARTR,X
   LDA ASSIGNARAVE+4,X
   STA IDAL,X
   DEX
   BPL -
   LDA ASSIGNARAVE+8
   STA IDYPE
   LDA ASSIGNARAVE+9
   STA EXPFFSET

   ;** GO ONTO NEXT UNRESOLVED EXPRESSION
   ASSIGNARASCADEONT = *
   LDX EXPFFSET
   LDA EXPEXTPND,X
   STA EXPFFSET
   LDY #0
-  LDA EXPEXTNRES,X
   STA EXPTR,Y
   INX
   INY
   CPY #4
   BCC -
   JMP ASSIGNARASCADE

FETCHXP = *  ;( [EXPTR] ) : EXPABLE, MP=EXPTR
   LDX #3
-  LDA EXPTR,X
   STA MP,X
   DEX
   BPL -
   LDA #<EXPABLE
   LDY #>EXPABLE
   STA ZP+0
   STY ZP+1
   LDA #16+14
   LDY #0
   JSR FETCH
   LDA EXPENGTH
   CMP #16+14+1
   BCC +
   LDA EXPENGTH
   LDY #0
   JSR FETCH
+  RTS

STASHXP = *  ;( [EXPTR], EXPABLE ) : MP=EXPTR
   LDX #3
-  LDA EXPTR,X
   STA MP,X
   DEX
   BPL -
   LDA #<EXPABLE
   LDY #>EXPABLE
   STA ZP+0
   STY ZP+1
   LDA EXPENGTH
   LDY #0
   JSR STASH
   RTS

FILLHYPE .BUF 1

FILLEMORYOLE = *  ;( .=HOLEYPE, VARTR, IDAL, IDYPE )
   STA FILLHYPE
   BIT DEBUG
   BPL FILLHONT
   LDA #<FILLHSG1
   LDY #>FILLHSG1
   JSR PUTS
   LDA VARTR+1
   JSR PUTHEX
   LDA VARTR+0
   JSR PUTHEX
   LDA #<FILLHSG2
   LDY #>FILLHSG2
   JSR PUTS
   LDX #IDAL
   JSR PUTNUM
   LDA #" "
   JSR PUTCHAR
   LDA #"("
   JSR PUTCHAR
   LDA #"V"
   LDX IDYPE
   BEQ +
   LDA #"A"
+  JSR PUTCHAR
   LDA #<FILLHSG3
   LDY #>FILLHSG3
   JSR PUTS
   LDA FILLHYPE
   JSR PUTHEX
   LDA #CHR
   JSR PUTCHAR
   ;%%%

   FILLHONT = *
   LDA FILLHYPE
   CMP #$40
   BEQ FILLHRANCH
   TAX
   DEX
-  LDA IDAL,X
   STA MEMUTALS,X
   DEX
   BPL -
   LDX FILLHYPE
   DEX
-  INX
   CPX #4
   BCS +
   LDA IDAL,X
   BEQ -
   LDA #ERRALUEOOARGE
   JMP ERROREF
+  LDA FILLHYPE
   LDX VARTR+0
   LDY VARTR+1
   JSR MEMUT
   ;** ADD RELOCATABLE REFERENCE
   LDA IDYPE
   BEQ +
   CMP #$04
   BCS +
   LDX VARTR+0
   LDY VARTR+1
   JSR RECORDELOCEF
+  RTS

   FILLHRANCH = *
   LDA IDAL+2
   ORA IDAL+3
   BEQ +
   LDA #ERRALUEOOARGE
   JMP ERROREF
+  CLC
   LDA VARTR+0
   ADC #1
   STA MEMUTALS+0
   LDA VARTR+1
   ADC #0
   STA MEMUTALS+1
   SEC
   LDA IDAL+0
   SBC MEMUTALS+0
   STA MEMUTALS+0
   TAX
   LDA IDAL+1
   SBC MEMUTALS+1
   STA MEMUTALS+1
   CMP #0
   BNE +
   CPX #128
   BCC ++
-  LDA #ERRRANCHOOAR
   JMP ERROR
+  CMP #$FF
   BNE -
   CPX #128
   BCC -
+  LDA #1
   LDX VARTR+0
   LDY VARTR+1
   JSR MEMUT
   RTS

FILLHSG1 = *
   .ASC "FILL MEMORY HOLE: ADDRESS=$"
   .BYTE 0
FILLHSG2 = *
   .ASC ", VALUE="
   .BYTE 0
FILLHSG3 = *
   .ASC "), HOLEYPE=$"
   .BYTE 0

;======== PROGRAM MEMORY STORAGE ========

MEMNIT = *  ;( )
   LDA #ACEEMULL
   STA MEMUFTR+3
   LDX #0
   LDA #ACEEMULL
-  STA MEMTRABLE,X
   INX
   BNE -
   RTS

MEMUTAVE .BUF 2

MEMUT = *  ;( .=ADDR,.=BYTEOUNT, MEMUTALS )
   STA MEMUTOUNT
   STY MEMUTAGE
   LDY #0

   MEMUTEXT = *
   LDA MEMUFTR+3
   CMP #ACEEMULL
   BEQ MEMUTISS
   LDA MEMUTAGE
   CMP MEMUFAGE
   BNE MEMUTISS
   LDA MEMUTALS,Y
   STA MEMUF,X
   INX
   BNE +
   INC MEMUTAGE
+  INY
   CPY MEMUTOUNT
   BCC MEMUTEXT
   RTS

   MEMUTISS = *
   STX MEMUTAVE+0
   STY MEMUTAVE+1
   JSR MEMLUSHUF
   JSR MEMETCHUF
   LDX MEMUTAVE+0
   LDY MEMUTAVE+1
   JMP MEMUTEXT

MEMLUSHUF = *
   LDA #<MEMUF
   LDY #>MEMUF
   STA ZP+0
   STY ZP+1
   ;** FLUSH OLD PAGE
   LDX #3
-  LDA MEMUFTR,X
   STA MP,X
   DEX
   BPL -
   LDA MP+3
   CMP #ACEEMULL
   BEQ +
   LDA MEMUFAGE
   AND #$03
   CLC
   ADC MP+1
   STA MP+1
   LDA #0
   LDY #1
   JSR STASH
+  RTS

MEMETCHUF = *  ;( MEMUTAGE )
   LDA #<MEMUF
   LDY #>MEMUF
   STA ZP+0
   STY ZP+1
   LDA MEMUTAGE
   STA MEMUFAGE
   AND #%11111100
   TAY
   LDX #0
-  LDA MEMTRABLE,Y
   STA MEMUFTR,X
   STA MP,X
   INY
   INX
   CPX #4
   BCC -
   LDA MP+3
   CMP #ACEEMULL
   BEQ MEMETCHUFEW
   LDA MEMUTAGE
   AND #$03
   CLC
   ADC MP+1
   STA MP+1
   LDA #0
   LDY #1
   JSR FETCH
   RTS
   
   MEMETCHUFEW = *
   LDA #0
   LDY #4
   JSR MALLOC
   LDA MEMUFAGE
   AND #%11111100
   TAY
   LDX #0
-  LDA MP,X
   STA MEMTRABLE,Y
   STA MEMUFTR,X
   INY
   INX
   CPX #4
   BCC -
   RTS

MEMAVEDDR .BUF 2
MEMAVED   .BUF 1
MEMAVEEN  .BUF 1  ;0==256

MEMAVE = *  ;( .=FD, .=FROM, ADDRESS=TO)
   STA MEMAVED
   STX MEMAVEDDR+0
   STY MEMAVEDDR+1
   JSR MEMLUSHUF

   MEMAVEEXT = *
   LDA MEMAVEDDR+0
   CMP ADDRESS+0
   LDA MEMAVEDDR+1
   SBC ADDRESS+1
   BCC +
   RTS
+  LDA MEMAVEDDR+1
   STA MEMUTAGE
   JSR MEMETCHUF   ;SETS (ZP)
   LDA #0
   STA MEMAVEEN
   ;** SET BOTTOM
   LDA MEMAVEDDR+0
   BEQ ++
   CLC
   LDA ZP+0
   ADC MEMAVEDDR+0
   STA ZP+0
   BCC +
   INC ZP+1
+  SEC
   LDA MEMAVEEN
   SBC MEMAVEDDR+0
   STA MEMAVEEN
   ;** SET TOP
+  LDA MEMAVEDDR+1
   CMP ADDRESS+1
   BCC +
   SEC
   LDA #0
   SBC ADDRESS+0
   TAX
   LDA MEMAVEEN
   STX MEMAVEEN
   SEC
   SBC MEMAVEEN
   STA MEMAVEEN
   ;** SAVE THE PAGE
+  LDY #0
   LDA MEMAVEEN
   BNE +
   INY
+  LDX MEMAVED
   JSR WRITE
   LDA MEMAVEEN
   BEQ +
   CLC
   ADC MEMAVEDDR+0
   STA MEMAVEDDR+0
   BCC ++
+  INC MEMAVEDDR+1
+  JMP MEMAVEEXT

RECORDELOCEF = *  ;( .=REFDDRESS, .=VALUEYPE )
   RTS

;======== TOKENIZER ========

;* FILL ENTIRE BUFFER, PAD WITH SPACES; .=EOF
FILLBUF = *
   LDA #<SOURCEUF
   LDY #>SOURCEUF
   STA ZP
   STY ZP+1
   LDA #0
   LDY #1
   STA BUFPTR
   LDX SOURCECB
   JSR READ
   BNE +
   SEC
   RTS
+  CPY #1
   BCC +
   CLC
   RTS
+  TAY
   LDA #" "
-  STA SOURCEUF,Y
   INY
   BNE -
   CLC
   RTS

GETEXTHAR = *
   INC BUFPTR
   BEQ +
-  LDY BUFPTR
   LDA SOURCEUF,Y
   RTS
+  JSR FILLBUF
   BCC -
   LDA #CHR
   RTS

EATHITESPACE = *  ;() : .=EXTHAR
   LDA PREVHAR
   CMP #" "
   BEQ +
   CMP #CHRAB
   BEQ +
   RTS
+  LDY BUFPTR
-  INY
   BEQ +
   EATHONT = *
   LDA SOURCEUF,Y
   CMP #" "
   BEQ -
   CMP #CHRAB
   BEQ -
   STY BUFPTR
   RTS
+  JSR FILLBUF
   BCS +
   LDY #0
   JMP EATHONT
+  LDA #CHR
   RTS

;*** TOKEN DISPATCH ***
;RET: .=TOKENDENTIFIER, .=NEXTHAR, .=STRLEN, STRINGEN, STRINGUF
;     .=TOKENUMBER,     .=NUMLEN, NUMBER
;     .=TOKENTRING,     .=FIRSTHAR,.=STRLEN, STRINGEN, STRINGUF
;     .=TOKENPECIAL,    .=CHAR

TOKEBUGAVE .BUF 3

GETOKEN = *
   LDA NEWOL
   STA SOURCEOL
   LDA NEWINE+0
   STA SOURCEINE+0
   LDA NEWINE+1
   STA SOURCEINE+1
   LDA NEWINE+2
   STA SOURCEINE+2
   LDA NEWINE+3
   STA SOURCEINE+3
   BIT DEBUG
   BPL GETOKENEAL
   JSR GETOKENEAL
   STA TOKEBUGAVE+0
   STX TOKEBUGAVE+1
   STY TOKEBUGAVE+2
   JSR DISPOKEN
   LDA TOKEBUGAVE+0
   LDX TOKEBUGAVE+1
   LDY TOKEBUGAVE+2
   RTS

GETOKENEAL = *
   LDA PREVHAR
   CMP #" "
   BNE +
-  JSR EATHITESPACE
+  CMP #CHRAB
   BEQ -
   CMP #"@"
   BCC +
   JMP GETDENTIFIER
+  CMP #"'"
   BCC CMPORE1
   BNE +
   JMP GETTRING
+  CMP #"0"
   BCC TOKPECIAL
   CMP #":"
   BCS +

   TOKUM = *
   JMP GETUMBER

+  CMP #";"
   BNE +
   JMP EATOMMENT

   TOKPECIAL = *
   JMP GETPECIALOKEN

   CMPORE1 = *
   CMP #"$"
   BCC +
   BEQ TOKUM
   CMP #"%"
   BEQ TOKUM
   JMP GETPECIALOKEN

+  CMP #CHRUOTE
   BNE TOKPECIAL
   JMP GETTRING

;*** COMMENT ***

EATOMMENT = *
   LDY BUFPTR
-  INY
   BEQ +

   COMMENTHAR = *
   LDA SOURCEUF,Y
   CMP #CHR
   BNE -
   STY BUFPTR
   JMP GETPECIALOKEN
+  JSR FILLBUF
   BCS +
   LDY #0
   BEQ COMMENTHAR
+  LDA #CHR
   JMP GETPECIALOKEN

;*** SPECIAL ***

GETPECIALOKEN = *
   CMP #CHR
   BNE +
   INC NEWINE+0
   BNE +
   INC NEWINE+1
   BNE +
   INC NEWINE+2
   BNE +
   INC NEWINE+3
+  CMP #CHR
   BNE +
   STA PREVHAR
   STA TOKENHAR
   LDX #TOKEN
   STX TOKENYPE
   RTS
+  PHA
   JSR GETEXTHAR
   STA PREVHAR
   STA TOKENEXTHAR
   PLA
   LDX #TOKENPECIAL
   STX TOKENYPE
   STA TOKENHAR
   RTS

;*** IDENTIFIER ***

GETDENTIFIER = *
   STA STRINGUF
   LDY #1
   STY STRINGEN
-  JSR GETEXTHAR
   CMP #"@"
   BCC IDENTXIT

   IDENTOODHAR = *
   LDY STRINGEN
   STA STRINGUF,Y
   INC STRINGEN
   CPY #240
   BCC -
   STA PREVHAR
   LDA #ERRDENTOOONG
   JMP ERROR

   IDENTXIT = *
   CMP #"."
   BEQ IDENTOODHAR
   CMP #"_"
   BEQ IDENTOODHAR
   CMP #"0"
   BCC +
   CMP #":"
   BCC IDENTOODHAR
+  CMP #" "
   BNE +
-  STA PREVHAR
   JSR EATHITESPACE
+  CMP #CHRAB
   BEQ -
   STA PREVHAR
   LDA #0
   LDY STRINGEN
   STA STRINGUF,Y
   LDA PREVHAR
   LDY STRINGEN
   LDX #TOKENDENTIFIER
   STX TOKENYPE
   CMP #";"
   BNE +
   LDA #CHR
+  STA TOKENEXTHAR
   RTS

;*** STRING ***

GETTRING = *
   STA STRELIMIT
   LDA #0
   STA STRINGEN
-  JSR GETEXTHAR
   STA PREVHAR
   CMP #CHR
   BEQ STROF
   CMP STRELIMIT
   BEQ STRXIT
   CMP #CHR
   BEQ STROF
   CMP #"\"
   BEQ STRSC
   GETTRUT = *
   LDY STRINGEN
   STA STRINGUF,Y
   INC STRINGEN
   LDA STRINGEN
   CMP #241
   BCC -
   STA PREVHAR
   LDA #ERRTRINGOOONG
   JMP ERROR

STRSC = *
   JSR GETEXTHAR
   CMP #CHR
   BEQ STROF
   CMP #CHR
   BEQ STROF
   LDX #STRSCHARND-STRSCHAR-1
-  CMP STRSCHAR,X
   BEQ +
   DEX
   BPL -
   JMP GETTRUT
+  LDA STRSCRANS,X
   JMP GETTRUT

STRSCHAR = *
   .ASC "\NBTRAZ'E0Q"
   .BYTE CHRUOTE
   STRSCHARND = *
STRSCRANS = *
   .BYTE 92,13,20,9,10,7,0,39,27,0,34,34

STROF = *
   LDA #ERROLOSEUOTE
   JMP ERROR

STRXIT = *
   JSR GETEXTHAR
   STA PREVHAR
   LDA #0  ;BUT MAY CONTAIN \0
   LDY STRINGEN
   STA STRINGUF,Y
   LDA STRINGUF+0
   LDX #TOKENTRING
   STX TOKENYPE
   STA TOKENHAR
   RTS

GETUMBER = *
   PHA
   LDX #3
   LDA #0
-  STA NUMBER,X
   DEX
   BPL -
   PLA
   LDX #16
   CMP #"$"
   BEQ +
   LDX #2
   CMP #"%"
   BEQ +
   LDX #10
   STX NUMASE
   BNE GOTEXTIGIT
+  STX NUMASE
   JSR GETEXTHAR
   STA PREVHAR
   JSR CHECKIGIT
   BCC +
   LDA #ERRADUMBER
   JMP ERROR
+  TXA
   JMP GOTEXTIGIT

NEXTIGIT = *
   JSR GETEXTHAR
   STA PREVHAR
   CMP #"_"
   BEQ NEXTIGIT
GOTEXTIGIT = *
   JSR CHECKIGIT
   BCS GETUMXIT
   PHA
   JSR SHIFTUMBER
   BCS OVERFLOWXITLA
   PLA
   CLC
   ADC NUMBER
   STA NUMBER
   BCC +
   INC NUMBER+1
   BNE +
   INC NUMBER+2
   BNE +
   INC NUMBER+3
   BEQ OVERFLOWXIT
+  JMP NEXTIGIT

OVERFLOWXITLA = *
   PLA
OVERFLOWXIT = *
   LDA #ERRUMVERFLOW
   JMP ERROR

GETUMXIT = *
   LDY #3
-  LDA NUMBER,Y
   BEQ +
   DEY
   BPL -
   INY
+  INY
   STY TOKENUMYTES
   LDX #TOKENUMBER
   STX TOKENYPE
   RTS

CHECKIGIT = *  ;( .=ASCIIIGIT ) : .=BINIGIT, .=ASCIIIGIT, .=OK
   TAX
   CMP #"0"
   BCC CHECKAD
   CMP #"9"+1
   BCC CHECKND
   CMP #"A"
   BCC CHECKAD
   CMP #"F"+1
   BCC +
   CMP #""
   BCC CHECKAD
   CMP #""+1
   BCS CHECKAD
+  SEC
   SBC #7
   CHECKND = *
   AND #$0F
   CMP NUMASE
   RTS
   CHECKAD = *
   SEC
   RTS

SHIFTUMBER = *
   LDA NUMASE
   CMP #10
   BNE +
   LDX #3
-  LDA NUMBER,X
   STA NUMAVE,X
   DEX
   BPL -
   LDX #2
   JSR ROLLUMBER
   JSR ADDUMBER
   LDX #1
   JSR ROLLUMBER
   RTS
+  LDX #1
   CMP #16
   BNE +
   LDX #4
+  JSR ROLLUMBER
   RTS

   ROLLUMBER = *  ;( .=TIMES )
   ASL NUMBER
   ROL NUMBER+1
   ROL NUMBER+2
   ROL NUMBER+3
   BCS +
   DEX
   BNE ROLLUMBER
   RTS
+  PLA
   PLA
   SEC
   RTS

   ADDUMBER = *
   LDX #0
   CLC
-  LDA NUMBER,X
   ADC NUMAVE,X
   STA NUMBER,X
   INX
   TXA
   AND #$03
   BNE -
   BCS +
   RTS
+  PLA
   PLA
   SEC
   RTS

;======== DEBUGGING TOKEN DISPLAY ROUTINES ========

DISPOKEN = *  ;( .TOKENYPE )
   LDX TOKENYPE
   CPX #TOKENDENTIFIER
   BEQ DISPDENTIFIER
   CPX #TOKENTRING
   BEQ DISPTRING
   CPX #TOKENPECIAL
   BNE +
   JMP DISPPECIAL
+  CPX #TOKENUMBER
   BNE +
   JMP DISPUMBER
+  RTS

DISPDENTIFIER = *
   LDA #"I"
   JSR PUTCHAR
   LDA #":"
   JSR PUTCHAR
   JSR SHOWTR
   LDA #","
   JSR PUTCHAR
   JSR HASH
   LDA #0
   STA NUMBER+2
   STA NUMBER+3
   LDA HASHAL+0
   LDY HASHAL+1
   STA NUMBER+0
   STY NUMBER+1
   LDX #NUMBER
   JSR PUTNUM
   LDA #","
   JSR PUTCHAR
   SEC
   LDA HASHTR+0
   SBC #<IDENTASHABLE
   STA NUMBER+0
   LDA HASHTR+1
   SBC #>IDENTASHABLE
   STA NUMBER+1
   LSR NUMBER+1
   ROR NUMBER+0
   LSR NUMBER+1
   ROR NUMBER+0
   LDX #NUMBER
   JSR PUTNUM
   LDA #","
   JSR PUTCHAR
   LDA TOKENEXTHAR
   SHOWHAR = *
   CMP #CHR
   BNE +
   LDA #"\"
   JSR PUTCHAR
   LDA #"N"
+  JSR PUTCHAR
   SHOW = *
   LDA #CHR
   JSR PUTCHAR
   RTS

DISPTRING = *
   LDA #"S"
   JSR PUTCHAR
   LDA #":"
   JSR PUTCHAR
   JSR SHOWTR
   JMP SHOW

SHOWTR = *
   LDA #<STRINGUF
   LDY #>STRINGUF
   STA ZP+0
   STY ZP+1
   LDA STRINGEN
   LDY #0
   LDX #STDOUT
   JSR WRITE
   RTS

DISPPECIAL = *
   LDA #"C"
   JSR PUTCHAR
   LDA #":"
   JSR PUTCHAR
   LDA TOKENHAR
   JMP SHOWHAR

DISPUMBER = *
   LDA #"N"
   JSR PUTCHAR
   LDA #":"
   JSR PUTCHAR
   LDA #<STRINGUF
   LDY #>STRINGUF
   STA ZP+0
   STY ZP+1
   LDX #NUMBER
   LDA #1
   JSR UTOA
   STY STRINGEN
   JSR SHOWTR
   JMP SHOW

;=== DYNAMIC MEMORY ROUTINES ===

MALLOCORK = MEMORK ;(16)  ;REQUIRED WORK AREA; DEFINED EARLIER

MALLOCEAD   .BUF 4
TPAREEIRST .BUF 1
TPAREEIN   .BUF 1
TPAREEAGES .BUF 1
TPAREATART .BUF 1
TPAREAND   .BUF 1

;*** MALLOCNIT()

MALLOCNIT = *
   LDA #ACEEMULL
   STA MALLOCEAD+3
   LDX #0
   LDA #$FF
-  STA TPAREEMAP,X
   INX
   BNE -
   LDX #>BSSND
   LDA #<BSSND
   BEQ +
   INX
+  STX TPAREEIRST
   STX TPAREATART
   LDX ACEEMOP+1
   STX MALLOCORK
   STX TPAREAND
   TXA
   SEC
   SBC TPAREEIRST
   BCS +
   LDA #0
+  STA TPAREEAGES
   CLC
   ADC #1
   STA TPAREEIN
   LDX TPAREEIRST
   CPX MALLOCORK
   BCS +
   LDA #$00
-  STA TPAREEMAP,X
   INX
   CPX MALLOCORK
   BCC -
+  RTS

LIBAGES .BUF 1

LIBAGELLOC = *  ;( .=PAGES ) : [MP]
   STA LIBAGES
   LDX #$00
   LDY #ACEEMNTERNAL-1
   JSR PAGEALLOC
   BCS +
   RTS
+  JSR TPAAGELLOC
   BCS +
   RTS
+  LDA LIBAGES
   LDX #ACEEMNTERNAL
   LDY #$FF
   JSR PAGEALLOC
   BCS +
   RTS
+  SEC
   ;RTS
   ;LDA #<NOMEMSG
   ;LDY #>NOMEMSG
   ;JSR EPUTS
   LDA #ERRNSUFFICIENTEMORY
   JMP ERROR

   ;NOMEMSG = *
   ;.BYTE CHR
   ;.ASC "NSUFFICIENT MEMORY, ABORTING."
   ;.BYTE CHR,0

NEWMAX   .BUF 1

TPAAGELLOC = *  ;( LIBAGES ) : [MP]
   LDA LIBAGES
   CMP TPAREEIN
   BCS TPAREEMAPULL
   ;** FIRST FREE
   LDX TPAREEIRST
   LDA TPAREEMAP,X
   BEQ ++
-  INX
   BEQ TPAREEMAPULL
   LDA TPAREEMAP,X
   BNE -
   STX TPAREEIRST
   JMP ++
   TPAREEMAPULL = *
   LDA LIBAGES
   CMP TPAREEIN
   BCS +
   STA TPAREEIN
+  SEC
   RTS

   ;** SEARCH
+  DEX
-  LDY LIBAGES
-  INX
   BEQ TPAREEMAPULL
   LDA TPAREEMAP,X
   BNE --
   DEY
   BNE -

   ;** ALLOCATE
   STX NEWMAX
   LDY LIBAGES
   LDA #$41
-  STA TPAREEMAP,X
   DEX
   DEY
   BNE -
   INX
   CPX TPAREEIRST
   BNE +
   LDY NEWMAX
   INY
   STY TPAREEIRST
+  SEC
   LDA TPAREEAGES
   SBC LIBAGES
   STA TPAREEAGES
   LDA #0
   LDY #ACEEMNTERNAL
   STA MP+0
   STX MP+1
   STA MP+2
   STY MP+3
   CLC
   RTS

MALLOCENAVE .BUF 3

MALLOC = *
QUICKALLOC = *
   STA MALLOCENAVE+0
   STY MALLOCENAVE+1
   JSR LIBALLOC
   BCS +
   RTS
+  LDX MALLOCENAVE+1
   LDA MALLOCENAVE+0
   BEQ +
   INX
+  TXA
   CPX #>1024
   BCS +
   LDX #>1024
+  TXA
   STA MALLOCENAVE+2
   JSR LIBAGELLOC
   BCC +
   RTS
+  LDA #0
   LDY MALLOCENAVE+2
   JSR FREE
   LDA MALLOCENAVE+0
   LDY MALLOCENAVE+1
   JMP MALLOC

;*** MALLOC( .=YTES ) : [MP]=AROINTER

MALLOCEMEXTTR = MALLOCORK+0 ;(4)
MALLOCEMENGTH  = MALLOCORK+4 ;(2)
MALLOCENGTH     = MALLOCORK+6 ;(2)
MALLOC          = MALLOCORK+8 ;(4)

LIBALLOC = *
   CLC
   ADC #7
   BCC +
   INY
+  AND #$F8
   STA MALLOCENGTH
   STY MALLOCENGTH+1
   LDX #3
-  LDA MALLOCEAD,X
   STA MP,X
   LDA #ACEEMULL
   STA MALLOC,X
   DEX
   BPL -

   MALLOCOOK = *
   LDA MP+3
   CMP #ACEEMULL
   BNE +

   MALLOCRRORXIT = *
   LDA #ACEEMULL
   STA MP+3
   LDA #ACERRNSUFFICIENTEMORY
   STA ERRNO
   SEC
   RTS

+  LDX #MALLOCEMEXTTR
   LDY #6
   JSR ZPLOAD
   LDA MALLOCEMENGTH
   CMP MALLOCENGTH
   LDA MALLOCEMENGTH+1
   SBC MALLOCENGTH+1
   BCS MALLOCOTLOCK
   LDX #3
-  LDA MP,X
   STA MALLOC,X
   LDA MALLOCEMEXTTR,X
   STA MP,X
   DEX
   BPL -
   JMP MALLOCOOK

   MALLOCOTLOCK = *
   LDA MALLOCEMENGTH
   CMP MALLOCENGTH
   BNE +
   LDA MALLOCEMENGTH+1
   SBC MALLOCENGTH+1
   BEQ MALLOCAKEHOLELOCK
+  SEC
   LDA MALLOCEMENGTH
   SBC MALLOCENGTH
   STA MALLOCEMENGTH
   LDA MALLOCEMENGTH+1
   SBC MALLOCENGTH+1
   STA MALLOCEMENGTH+1
   LDX #MALLOCEMEXTTR
   LDY #6
   JSR ZPSTORE
   CLC
   LDA MP+0
   ADC MALLOCEMENGTH
   STA MP+0
   LDA MP+1
   ADC MALLOCEMENGTH+1
   STA MP+1
   CLC
   RTS

   MALLOCAKEHOLELOCK = *
   LDA MALLOC+3
   CMP #ACEEMULL
   BNE +
   LDX #3
-  LDA MALLOCEMEXTTR,X
   STA MALLOCEAD,X
   DEX
   BPL -
   CLC
   RTS
+  LDX #3
-  LDA MP,X
   LDY MALLOC,X
   STA MALLOC,X
   STY MP,X
   DEX
   BPL -
   LDX #MALLOCEMEXTTR
   LDY #4
   JSR ZPSTORE
   LDX #3
-  LDA MALLOC,X
   STA MP,X
   DEX
   BPL -
   CLC
   RTS

;*** FREE( [MP]=AROINTER, .=ENGTH )  ALTERS [MP]

FREEEMEXTTR = MALLOCORK+0  ;(4)
FREEEMENGTH  = MALLOCORK+4  ;(2)
FREEENGTH     = MALLOCORK+6  ;(2)
FREEEWTR     = MALLOCORK+8  ;(4)
FREE          = MALLOCORK+12 ;(4)

FREE = *
   CLC
   ADC #7
   BCC +
   INY
+  AND #$F8
   STA FREEENGTH+0
   STY FREEENGTH+1
   LDX #3
-  LDA MP,X
   STA FREEEWTR,X
   LDA MALLOCEAD,X
   STA MP,X
   LDA #ACEEMULL
   STA FREE,X
   DEX
   BPL -

   FREEEARCHOOP = *
   LDA MP+3
   CMP #ACEEMULL
   BEQ FREEOALESCEANDEW
   LDA MP+0
   CMP FREEEWTR+0
   LDA MP+1
   SBC FREEEWTR+1
   LDA MP+2
   SBC FREEEWTR+2
   LDA MP+3
   SBC FREEEWTR+3
   BCS FREEOALESCEANDEW
+  LDX #FREEEMEXTTR
   LDY #4
   JSR ZPLOAD
   LDX #3
-  LDA MP,X
   STA FREE,X
   LDA FREEEMEXTTR,X
   STA MP,X
   DEX
   BPL -
   BMI FREEEARCHOOP

   FREEOALESCEANDEW = *
   LDX #3
-  LDA FREE,X
   STA MP,X
   DEX
   BPL -
   LDA MP+3
   CMP #ACEEMULL
   BNE +
   ;** PREV IS HEAD
   LDX #3
-  LDA MALLOCEAD,X
   STA FREEEMEXTTR,X
   LDA FREEEWTR,X
   STA MALLOCEAD,X
   DEX
   BPL -
   LDA FREEENGTH+0
   LDY FREEENGTH+1
   STA FREEEMENGTH+0
   STY FREEEMENGTH+1
   JMP FREEOALESCEEWND

   ;** PREV IS REAL
+  LDX #FREEEMEXTTR
   LDY #6
   JSR ZPLOAD
   LDA MP+3
   CMP FREEEWTR+3
   BNE +
   LDA MP+2
   CMP FREEEWTR+2
   BNE +
   CLC
   LDA MP+0
   ADC FREEEMENGTH
   TAX
   LDA MP+1
   ADC FREEEMENGTH+1
   CMP FREEEWTR+1
   BNE +
   CPX FREEEWTR
   BNE +
   ;** PREV DOES COALESCE
   CLC
   LDA FREEEMENGTH
   ADC FREEENGTH
   STA FREEEMENGTH
   LDA FREEEMENGTH+1
   ADC FREEENGTH+1
   STA FREEEMENGTH+1
   LDX #3
-  LDA FREE,X
   STA FREEEWTR,X
   DEX
   BPL -
   BMI FREEOALESCEEWND

   ;** PREV DOES NOT COALESCE
+  LDX #FREEEWTR
   LDY #4
   JSR ZPSTORE
   LDA FREEENGTH+0
   LDY FREEENGTH+1
   STA FREEEMENGTH+0
   STY FREEEMENGTH+1

   FREEOALESCEEWND = *
   LDA FREEEWTR+3
   CMP FREEEMEXTTR+3
   BNE +
   LDA FREEEWTR+2
   CMP FREEEMEXTTR+2
   BNE +
   CLC
   LDA FREEEWTR
   ADC FREEEMENGTH
   TAX
   LDA FREEEWTR+1
   ADC FREEEMENGTH+1
   CMP FREEEMEXTTR+1
   BNE +
   CPX FREEEMEXTTR
   BNE +

   ;** NEW AND NEXT COALESCE
   LDX #3
-  LDA FREEEMEXTTR,X
   STA MP,X
   DEX
   BPL -
   LDA FREEEMENGTH+1
   PHA
   LDA FREEEMENGTH+0
   PHA
   LDX #FREEEMEXTTR
   LDY #6
   JSR ZPLOAD
   CLC
   PLA
   ADC FREEEMENGTH+0
   STA FREEEMENGTH+0
   PLA
   ADC FREEEMENGTH+1
   STA FREEEMENGTH+1

+  LDX #3
-  LDA FREEEWTR,X
   STA MP,X
   DEX
   BPL -
   LDX #FREEEMEXTTR
   LDY #6
   JSR ZPSTORE
   CLC
   RTS

;======== STANDARD LIBRARY ========

EPUTS = *
   LDX #STDERR
   JMP FPUTS
PUTS = *
   LDX #STDOUT
FPUTS = *
   STA ZP+0
   STY ZP+1
FPUTSP = *
   LDY #$FF
-  INY
   LDA (ZP),Y
   BNE -
   TYA
   LDY #0
   JMP WRITE

PUTCHAR = *
   LDX #STDOUT
PUTC = *
   STA PUTCUFFER
   LDA #<PUTCUFFER
   LDY #>PUTCUFFER
   STA ZP+0
   STY ZP+1
   LDA #1
   LDY #0
   JMP WRITE
   PUTCUFFER .BUF 1

GETARG = *
   STY ZP+1
   ASL
   STA ZP+0
   ROL ZP+1
   CLC
   LDA ACERGV
   ADC ZP+0
   STA ZP+0
   LDA ACERGV+1
   ADC ZP+1
   STA ZP+1
   LDY #0
   LDA (ZP),Y
   TAX
   INY
   LDA (ZP),Y
   STX ZP+0
   STA ZP+1
   LDA ZP+0
   LDY ZP+1
   RTS

;END OF FILE + BLANK LINE

