;***  FILE ENCODER VERSION 1.00 - BY RAIG RUCE - 10-EP-94

;KAR [-HELP] FILE ...

;EVIN'S CHIVER FORMAT, CREATED BY EVIN HILLIPS AND RAIG RUCE, 1991

.SEQ ACEHEAD.S
.ORG ACEPPDDRESS
.OBJ "@0:KAR"

JMP MAIN
.BYTE ACE1,ACE2,ACE3
.BYTE 64,0  ;** STACK,RESERVED

;*** GLOBAL DECLARATIONS

CHR = $07
CHR = $09
CHR = $0A
CHR = $0D
CHR = $14
CHR = $93
CHR = $22

ARG          =  2 ;(2)  ;CURRENT ARGUMENT NUMBER
NAME         =  4 ;(2)  ;NAME OF FILE BEING KARED
INUFEN     = 10 ;(2)  ;TOTAL SIZE OF INPUT BUFFER
CBUFEN      = 12 ;(1)  ;TOTAL SIZE OF LINE-COUNTING INPUT BUFFER
FILEOUNT    = 24 ;(4)  ;FILES TO PUT INTO ARCHIVE
LINEOUNT    = 28 ;(4)  ;LINES IN CURRENT FILE
INILE       = 32 ;(1)  ;INPUT FILE DESCRIPTOR
LASTILEHAR = 33 ;(1)  ;LAST CHAR READ WHILE COUNTING A FILE
WORK         = 112 ;(16);TEMPORARY WORK AREA, LOWEST LEVEL

;===MAIN===

MAIN = *
   ;** CHECK FOR A LARGE ENOUGH 
   SEC
   LDA #<BSSND
   CMP ACEEMOP+0
   LDA #>BSSND
   SBC ACEEMOP+1
   BCS +
   JMP MAINNIT
+  LDA #<TPASG
   LDY #>TPASG
   JSR EPUTS
DIE = *
   LDA #1
   LDX #0
   JMP EXIT

TPASG = *
   .ASC "NSUFFICIENT PROGRAM SPACE TO RUN"
   .BYTE CHR,0

USAGE = *
   LDA #<USAGESG
   LDY #>USAGESG
   JSR EPUTS
   JMP DIE

USAGESG = *
   .ASC "USAGE: KAR [-HELP] FILE ..."
   .BYTE CHR,0

MAINNIT = *
   LDA #0
   STA ARG+0
   STA ARG+1
   JSR PUTILEOUNT

   MAINEXT = *
   JSR CHECKTOP
   INC ARG+0
   BNE +
   INC ARG+1
+  LDA ARG+0
   LDY ARG+1
   JSR GETARG
   BEQ MAINXIT
   LDA ZP+0
   LDY ZP+1
   STA NAME+0
   STY NAME+1
   JSR KAR
   JMP MAINEXT

MAINXIT = *
   RTS

CHECKTOP = *
   JSR STOPKEY
   BCS +
   RTS
+  LDA #<STOPPEDSG
   LDY #>STOPPEDSG
   JSR EPUTS
   JMP DIE

   STOPPEDSG = *
   .ASC "<TOPPED>"
   .BYTE CHR,0

PUTILEOUNT = *
   LDA ACERGC+0
   LDY ACERGC+1
   LDX #$00
   STA FILEOUNT+0
   STY FILEOUNT+1
   STX FILEOUNT+2
   STX FILEOUNT+3
   LDA #1
   LDY #0
   JSR GETARG
   LDY #0
   LDA (ZP),Y
   CMP #"-"
   BNE +
   JMP USAGE
+  LDA FILEOUNT+0
   BNE +
   DEC FILEOUNT+1
+  DEC FILEOUNT+0
   LDX #FILEOUNT
   ;XX FALL THROUGH
   
PUTNUM = *  ;( .=ZPOFF )
   LDA #<NUMBUF
   LDY #>NUMBUF
   STA ZP+0
   STY ZP+1
   LDA #1
   JSR UTOA
   LDA #<NUMBUF
   LDY #>NUMBUF
   JSR PUTS
   LDA #CHR
   JSR PUTCHAR
   RTS

   NUMBUF .BUF 11

KAR = *
   JSR ECHO
   LDA NAME+0
   LDY NAME+1
   JSR PUTS
   LDA #CHR
   JSR PUTCHAR
   JSR COUNTINES
   BCC +
   RTS
+  LDX #LINEOUNT
   JSR PUTNUM
   ;** OPEN FILE
   LDA NAME+0
   LDY NAME+1
   STA ZP+0
   STY ZP+1
   LDA #"R"
   JSR OPEN
   BCC +
   JSR ECHOAME
   LDA #<OPENRRSG
   LDY #>OPENRRSG
   JSR EPUTS
   RTS
+  STA INILE
   JSR KARODY
   LDA INILE
   JSR CLOSE
   RTS
   OPENRRSG = *
   .ASC ": CANNOT OPEN"
   .BYTE CHR,0

ECHO = *
   LDA #<ECHOSG1
   LDY #>ECHOSG1
   JSR EPUTS
   JSR ECHOAME
   LDA #<ECHOSG2
   LDY #>ECHOSG2
   JMP EPUTS
ECHOSG1 = *
   .ASC "KARING "
   .BYTE CHR,0
ECHOSG2 = *
   .BYTE CHR,CHR,0

ECHOAME = *
   LDA NAME+0
   LDY NAME+1
   JSR EPUTS
   RTS

KARODY = *
   JSR INITNUF
-  JSR CHECKTOP
   LDA #<INUF
   LDY #>INUF
   STA ZP+0
   STY ZP+1
   LDA INUFEN+0
   LDY INUFEN+1
   LDX INILE
   JSR READ
   BCS ++
   BEQ +
   PHA
   TYA
   PHA
   JSR CHECKTOP
   PLA
   TAY
   PLA
   LDX #STDOUT
   JSR WRITE
   BCC -
   BCS ++
+  RTS
+  JSR ECHOAME
   LDA #<IORRSG
   LDY #>IORRSG
   JSR EPUTS
   RTS
   IORRSG = *
   .ASC ": READ/WRITE ERROR"
   .BYTE CHR,0

;=== LINE COUNTING PORTION ===

COUNTINES = *
   LDA NAME+0
   LDY NAME+1
   STA ZP+0
   STY ZP+1
   LDA #"R"
   JSR OPEN
   BCC +
   JSR ECHOAME
   LDA #<OPENRRSG
   LDY #>OPENRRSG
   JSR EPUTS
   SEC
   RTS
+  STA INILE
   JSR COUNTNIT
   JSR COUNTODY
   LDA INILE
   JSR CLOSE
   RTS

COUNTNIT = *
   LDA #0
   LDX #3
-  STA LINEOUNT,X
   DEX
   BPL -
   RTS

COUNTODY = *
-  JSR CHECKTOP
   LDA #<INUF
   LDY #>INUF
   STA ZP+0
   STY ZP+1
   LDA #254
   LDY #0
   LDX INILE
   JSR READ
   STA CBUFEN
   BEQ +
   JSR COUNTCANUFFER
   JMP -
+  RTS

COUNTCANUFFER = *  ;THIS SEEMS TO CAUSE ALL OF THE PROBLEMS...?
   LDY #0
-  LDA INUF,Y
   CMP #CHR
   BNE +
   INC LINEOUNT+0
   BNE +
   INC LINEOUNT+1
   BNE +
   INC LINEOUNT+2 
   BNE +
   INC LINEOUNT+3
+  INY
   CPY CBUFEN
   BCC -
   STA LASTILEHAR
   RTS

;=== STANDARD LIBRARY ===

PUTS = *
   LDX #STDOUT
FPUTS = *
   STA ZP+0
   STY ZP+1
   LDY #$FF
-  INY
   LDA (ZP),Y
   BNE -
   TYA
   LDY #0
   JMP WRITE
EPUTS = *
   LDX #STDERR
   JMP FPUTS

EPUTCHAR = *
   LDX #STDERR
   JMP PUTC
PUTCHAR = *
   LDX #STDOUT
PUTC = *
   STA PUTCUFFER
   LDA #<PUTCUFFER
   LDY #>PUTCUFFER
   STA ZP+0
   STY ZP+1
   LDA #1
   LDY #0
   JMP WRITE
   PUTCUFFER .BUF 1

GETARG = *
   STY ZP+1
   ASL
   STA ZP+0
   ROL ZP+1
   CLC
   LDA ACERGV+0
   ADC ZP+0
   STA ZP+0
   LDA ACERGV+1
   ADC ZP+1
   STA ZP+1
   LDY #0
   LDA (ZP),Y
   TAX
   INY
   LDA (ZP),Y
   STX ZP+0
   STA ZP+1
   ORA ZP+0
   RTS

INITNUF = *
   SEC
   LDA ACEEMOP+0
   SBC #<INUF
   STA INUFEN+0
   LDA ACEEMOP+1
   SBC #>INUF
   STA INUFEN+1
   RTS

;===BSS===

BSS    = *
INUF  = BSS+0
BSSND = INUF+256
