;*** MORE TEXT FILE DISPLAYER VERSION 1.00 - BY RAIG RUCE - 23-EB-94

;MORE [-HELP] FILE ...

.SEQ ACEHEAD.S
.ORG ACEPPDDRESS
.OBJ "@0:MORE"

JMP MAIN
.BYTE ACE1,ACE2,ACE3
.BYTE 64,0  ;** STACK,RESERVED

;*** GLOBAL DECLARATIONS

CHR = $07
CHR = $09
CHR = $0A
CHR = $0D
CHR = $14
CHR = $93
TRUE   = $FF
FALSE  = $00

ARG         = 2  ;(2)  ;CURRENT ARGUMENT NUMBER
NAME        = 4  ;(2)  ;NAME OF FILE BEING BCODED
ROW         = 6  ;(1)  ;CURRENT ROW ON DISPLAY
ROWDDR     = 8  ;(2)  ;ADDRESS OF CURRENT ROW ON DISPLAY
ROWNC      = 10 ;(2)  ;INCREMENT BETWEEN SUCCESSIVE ROWS ON DISPLAY
ROWOME     = 12 ;(2)  ;ADDRESS OF HOME POSITION ON DISPLAY
SCROWS     = 14 ;(1)  ;NUMBER OF ROWS ON DISPLAY
SCROLS     = 15 ;(1)  ;NUMBER OF COLUMNS ON DISPLAY
FILEINE    = 16 ;(4)  ;LINE NUMBER IN CURRENT FILE
INUFTR    = 20 ;(1)  ;NEXT BYTE TO EXTRACT FROM INPUT BUFFER
INUFALID  = 21 ;(1)  ;NUMBER OF VALID BYTES IN INPUT BUFFER
INUFD     = 22 ;(1)  ;FILE DESCRIPTOR FOR INPUT
POS         = 23 ;(1)  ;SCAN POSITION
GLUFHAR   = 24 ;(1)  ;BUFFERED CHARACTER FOR GETLINE
GLUFOF    = 25 ;(1)  ;WHETHER BUFFED CHAR IS EOF FOR GETLINE
PROMPTOLOR = 26 ;(1)  ;COLOR OF "MORE" PROMPT
TEXTOLOR   = 27 ;(1)  ;COLOR OF REGULAR TEXT
PROMPTEN   = 28 ;(1)  ;LENGTH OF PROMPT STRING
CATTRTR   = 30 ;(2)  ;STRING POINTER FOR CAT OPERATION
CURSOROLOR = 32 ;(1)  ;COLOR OF CURSOR ON "MORE" PROMPT
FILEARM    = 33 ;(1)  ;FLAG THAT A FILENAME HAS APPEARED

;===MAIN===

MAIN = *
   ;** CHECK FOR LARGE ENOUGH 
   SEC
   LDA #<BSSND
   CMP ACEEMOP+0
   LDA #>BSSND
   SBC ACEEMOP+1
   BCS +
   JMP MAINNIT
+  LDA #<TPASG
   LDY #>TPASG
   JSR EPUTS
DIE = *
   LDA #1
   LDX #0
   JMP EXIT

TPASG = *
   .ASC "NSUFFICIENT PROGRAM SPACE TO RUN MORE"
   .BYTE CHR,0

USAGE = *
   LDA #<USAGESG
   LDY #>USAGESG
   JSR EPUTS
   JMP DIE

USAGESG = *
   .ASC "USAGE: MORE [-HELP] FILE ..."
   .BYTE CHR,0

WINDOWSG = *
   .ASC "ERROR: DISPLAY MUST HAVE AT LEAST 10 COLUMNS AND 2 ROWS."
   .BYTE CHR,0

MAINNIT = *
   LDA #FALSE
   STA FILEARM
   LDA #0
   STA ARG+0
   STA ARG+1
   JSR WINSIZE
   STA SCROWS
   STX SCROLS
   CPX #10
   BCC +
   CMP #2
   BCS ++
+  LDA #<WINDOWSG
   LDY #>WINDOWSG
   JSR EPUTS
   JMP DIE
+  LDA SYSWORK+2
   LDY SYSWORK+3
   STA ROWOME+0
   STY ROWOME+1
   LDA SYSWORK+4
   LDY SYSWORK+5
   STA ROWNC+0
   STY ROWNC+1

   MAINEXT = *
   JSR CHECKTOP
   INC ARG+0
   BNE +
   INC ARG+1
+  LDA ARG+0
   LDY ARG+1
   JSR GETARG
   BEQ MAINXIT
   LDA ZP+0
   LDY ZP+1
   STA NAME+0
   STY NAME+1
   LDY #0
   LDA (ZP),Y
   CMP #"-"
   BNE +
   JMP USAGE
+  JSR MORE
   JMP MAINEXT

MAINXIT = *
   LDA FILEARM
   BEQ +
   JSR SCRHUTDOWN
+  RTS

CHECKTOP = *
   JSR STOPKEY
   BCS +
   RTS
+  LDA #<STOPPEDSG
   LDY #>STOPPEDSG
   JSR EPUTS
   JMP DIE

   STOPPEDSG = *
   .ASC "<TOPPED>"
   .BYTE CHR,0

MORE = *
   LDA FILEARM
   BNE +
   LDA #TRUE
   STA FILEARM
   JSR SCRNIT
+  JSR SCRLEAR
   LDA #0
   LDX #3
-  STA FILEINE,X
   DEX
   BPL -
   LDA NAME+0
   LDY NAME+1
   JSR INITETBYTE
   BCC +
   LDA #2
   JSR PROMPT
   CMP #"Q"
   BEQ MOREXIT
   CMP #$03
   BEQ MOREXIT
   RTS
+  JSR GETLINENIT
   BCS +

   MOREEXTINE = *
   JSR GETLINE
   BCS MORE
   JSR PUTLINE
   LDX ROW
   INX
   CPX SCROWS
   BCC MOREEXTINE
   BIT GLUFOF
   BMI MORE
   MOREROMPT = *
   LDA #0
   JSR PROMPT
   CMP #"Q"
   BEQ MOREXIT
   CMP #$03
   BEQ MOREXIT
   CMP #"N"
   BNE +
   LDA INUFD
   JSR CLOSE
   RTS
+  CMP #CHR
   BEQ MORE
   CMP #$11
   BEQ MORE
   CMP #"B"
   BEQ MOREACK
   JSR SCRLEAR
   JMP MOREEXTINE

   MORE = *
   LDA #1
   JSR PROMPT
   CMP #"Q"
   BEQ MOREXIT
   CMP #$03
   BEQ MOREXIT
   LDA INUFD
   JSR CLOSE
   RTS

MOREXIT = *
   LDA INUFD
   JSR CLOSE
   JSR SCRHUTDOWN
   LDA #0
   LDX #0
   JMP EXIT

MORE = *
   LDX ROW
   INX
   CPX SCROWS
   BCC +
   LDA #" "
   STA SYSWORK+4
   LDA #$88
   LDX #1
   JSR WINSCROLL
   DEC ROW
   SEC
   LDA ROWDDR+0
   SBC ROWNC+0
   STA ROWDDR+0
   LDA ROWDDR+1
   SBC ROWNC+1
   STA ROWDDR+1
+  JMP MOREEXTINE

MOREACK = *
   LDA #CHR
   JSR CONPUTCHAR
   JMP MOREROMPT

;=== STANDARD LIBRARY ===

PUTS = *
   LDX #STDOUT
FPUTS = *
   STA ZP+0
   STY ZP+1
   LDY #$FF
-  INY
   LDA (ZP),Y
   BNE -
   TYA
   LDY #0
   JMP WRITE
EPUTS = *
   LDX #STDERR
   JMP FPUTS

EPUTCHAR = *
   LDX #STDERR
   JMP PUTC
PUTCHAR = *
   LDX #STDOUT
PUTC = *
   STA PUTCUFFER
   LDA #<PUTCUFFER
   LDY #>PUTCUFFER
   STA ZP+0
   STY ZP+1
   LDA #1
   LDY #0
   JMP WRITE
   PUTCUFFER .BUF 1

GETARG = *
   STY ZP+1
   ASL
   STA ZP+0
   ROL ZP+1
   CLC
   LDA ACERGV+0
   ADC ZP+0
   STA ZP+0
   LDA ACERGV+1
   ADC ZP+1
   STA ZP+1
   LDY #0
   LDA (ZP),Y
   TAX
   INY
   LDA (ZP),Y
   STX ZP+0
   STA ZP+1
   ORA ZP+0
   RTS

INITETBYTE = *  ;( (.)=FILENAME ) : .=OPENRROR
   STA ZP+0
   STY ZP+1
   LDA #"R"
   JSR OPEN
   BCS +
   STA INUFD
   LDA #0
   STA INUFALID
   STA INUFTR
   CLC
+  RTS

GETBYTE = *  ;( ) : .=BYTE, .=EOF
   LDX INUFTR
   CPX INUFALID
   BCS FILLNUF
   LDA INUF,X
   INC INUFTR
   CLC
   RTS

FILLNUF = *
   JSR CHECKTOP
   LDA #<INUF
   LDY #>INUF
   STA ZP+0
   STY ZP+1
   LDA #<250
   LDY #>250
   LDX INUFD
   JSR READ
   BEQ +
   BCS +
   STA INUFALID
   LDA #0
   STA INUFTR
   JMP GETBYTE
+  LDA #0
   STA INUFTR
   STA INUFALID
   SEC
   RTS

GETLINENIT = *
   LDA #FALSE
   STA GLUFOF
   JMP GETLINEXIT

GETLINE = *
   LDX #0
   STX POS
   SEC
   LDA GLUFOF
   BNE +
   LDA GLUFHAR
   CLC
   BCC +

   GETLINEEXTHAR = *
   JSR GETBYTE
+  BCS GETLINE
   CMP #CHR
   BEQ GETLINE
   CMP #CHR
   BEQ GETLINE
   CMP #CHR
   ;BEQ GETLINE
   LDX POS
   STA LINE,X
   INX
   STX POS
   CPX SCROLS
   BCC GETLINEEXTHAR
   ;** LINE WRAP
   JSR GETBYTE
   CMP #CHR
   BEQ GETLINE
   CLC
   BCC GETLINEXITOET

GETLINEXIT = *
   JSR GETBYTE
   GETLINEXITOET = *
   STA GLUFHAR
   BCC +
   LDA #TRUE
   STA GLUFOF
+  LDA POS
   STA LINEEN
   CLC
   RTS

GETLINE = *
   INC FILEINE+0
   BNE +
   INC FILEINE+1
   BNE +
   INC FILEINE+2
   BNE +
   INC FILEINE+3
+  JMP GETLINEXIT

GETLINE = *
   LDA #TRUE
   STA GLUFOF
   SEC
   RTS

GLABDD .BUF 1

GETLINE = *
   LDX POS
   LDY #8
   LDA #" "
-  STA LINE,X
   INX
   DEY
   BNE -
   LDA POS
   AND #7
   STA GLABDD
   SEC
   LDA #8
   SBC GLABDD
   CLC
   ADC POS
   CMP SCROLS
   BCC +
   JMP GETLINEXIT
+  STA POS
   JMP GETLINEEXTHAR

GETLINE = *
   BRK

SCRNIT = *
   JSR CONPALETTE
   LDA SYSWORK+4
   STA PROMPTOLOR
   LDA SYSWORK+0
   STA TEXTOLOR
   LDA SYSWORK+1
   STA CURSOROLOR
   LDA #$60
   LDX #" "
   LDY SYSWORK+0
   JSR WINCLS
   ;** FALL THROUGH

SCRLEAR = *
   LDA #$80
   LDX #" "
   JSR WINCLS
   LDA #0
   STA ROW
   LDA ROWOME+0
   LDY ROWOME+1
   STA ROWDDR+0
   STY ROWDDR+1
   RTS

SCRHUTDOWN = *
   SEC
   LDA SCROWS
   SBC #1
   LDX #0
   JSR CONPOS
   RTS

PUTLINE = *
   LDA ROWDDR+0
   LDY ROWDDR+1
   STA SYSWORK+0
   STY SYSWORK+1
   LDA #<LINE
   LDY #>LINE
   STA SYSWORK+2
   STY SYSWORK+3
   LDA #$80
   LDX LINEEN
   STX SYSWORK+5
   JSR WINPUT
   INC ROW
   CLC
   LDA ROWDDR+0
   ADC ROWNC+0
   STA ROWDDR+0
   LDA ROWDDR+1
   ADC ROWNC+1
   STA ROWDDR+1
   RTS

SCRCROLL = *
   BRK

PROMPTHAR .BUF 1

PROMPT = *  ;(.=PROMPTYPE0:MORE,1:EOF,2:ERROR) : .=KEYHAR
   ;** GET PROMPT STRING
   LDX #0
   STX STRING+0
   ASL
   TAX
   LDA PROMPTAB+1,X
   TAY
   LDA PROMPTAB+0,X
   JSR CATTRING
   LDA NAME+0
   LDY NAME+1
   JSR CATTRING
   LDA #<PROMPTOLON
   LDY #>PROMPTOLON
   JSR CATTRING
   LDA #<NUMBUF
   LDY #>NUMBUF
   STA ZP+0
   STY ZP+1
   LDA #1
   LDX #FILEINE
   JSR UTOA
   LDA #<NUMBUF
   LDY #>NUMBUF
   JSR CATTRING
   LDA #<PROMPTLOSE
   LDY #>PROMPTLOSE
   JSR CATTRING
   STX PROMPTEN
   INX
   CPX SCROLS
   BCC +
   LDX SCROLS
   DEX
   STX PROMPTEN
+  JSR RVSTRING
   ;** DISPLAY PROMPT
   LDA ROWDDR+0
   LDY ROWDDR+1
   STA SYSWORK+0
   STY SYSWORK+1
   LDA #<STRING
   LDY #>STRING
   STA SYSWORK+2
   STY SYSWORK+3
   LDA #$E0
   LDX PROMPTEN
   STX SYSWORK+5
   LDY PROMPTOLOR
   JSR WINPUT
   ;** DISPLAY CURSOR
   CLC
   LDA ROWDDR+0
   ADC PROMPTEN
   STA SYSWORK+0
   LDA ROWDDR+1
   ADC #0
   STA SYSWORK+1
   LDA #$FF
   LDY CURSOROLOR
   JSR WINCURSOR
   ;** GET KEY
   JSR GETKEY
   STA PROMPTHAR
   ;** ERASE CURSOR
   CLC
   LDA ROWDDR+0
   ADC PROMPTEN
   STA SYSWORK+0
   LDA ROWDDR+1
   ADC #0
   STA SYSWORK+1
   LDA #$00
   JSR WINCURSOR
   ;** ERASE PROMPT
   LDA ROWDDR+0
   LDY ROWDDR+1
   STA SYSWORK+0
   STY SYSWORK+1
   LDA #" "
   STA SYSWORK+4
   LDA PROMPTEN
   STA SYSWORK+5
   LDA #$E0
   LDX #0
   LDY TEXTOLOR
   JSR WINPUT
   LDA PROMPTHAR
   RTS

PROMPTAB .WORD PROMPTORE,PROMPT,PROMPTRROR
PROMPTORE = *
   .ASC "--ORE-- ("
   .BYTE 0
PROMPT = *
   .ASC "---- ("
   .BYTE 0
PROMPTRROR = *
   .ASC "--!-- ("
   .BYTE 0
PROMPTOLON = *
   .ASC ":"
   .BYTE 0
PROMPTLOSE = *
   .ASC ")"
   .BYTE 0

CATTRING = *  ;( (.)=STRING ) : .=STREN
   STA CATTRTR+0
   STY CATTRTR+1
   LDX #255
-  INX
   LDA STRING,X
   BNE -
   LDY #0
-  LDA (CATTRTR),Y
   STA STRING,X
   BEQ +
   INY
   INX
   BNE -
+  RTS

RVSTRING = *
   LDY #0
   RVSTRINGEXT = *
   LDA STRING,Y
   BNE +
   RTS
+  PHA
   SEC
   SBC #32
   AND #%01000000
   BNE +
   PLA
   SEC
   SBC #64
   JMP ++
+  PLA
   CLC
   ADC #64
+  STA STRING,Y
   INY
   JMP RVSTRINGEXT

;===BSS===

BSS = *
INUF    = BSS+0
LINEREV = INUF+256+0
LINEEXT = INUF+256+4
LINEUM  = INUF+256+8
LINEEN  = INUF+256+12
LINE     = INUF+256+13
STRING   = LINEREV+256
NUMBUF   = STRING+256
BSSND   = NUMBUF+12
