;***  ITMAP IEWER 1.20 - BY RAIG RUCE - 10-EP-94

;VBM [-HELP] FILE ...

.SEQ ACEHEAD.S
.ORG ACEPPDDRESS
.OBJ "@0:VBM"

JMP MAIN
.BYTE ACE1,ACE2,ACE3
.BYTE 64,0  ;** STACK,RESERVED

;*** GLOBAL DECLARATIONS

CHR = $07
CHR = $09
CHR = $0A
CHR = $0D
CHR = $14
CHR = $93
CHR = $22

ARG          =  2 ;(2)  ;CURRENT ARGUMENT NUMBER
NAME         =  4 ;(2)  ;NAME OF FILE BEING KARED
INUFEN     =  6 ;(2)  ;TOTAL SIZE OF INPUT BUFFER
INILE       =  8 ;(1)  ;INPUT FILE DESCRIPTOR
ASPECT       = 10 ;(1)  ;X
BMOLS       = 11 ;(1)  ;X
BMOWS       = 12 ;(2)  ;X
TOPARGIN    = 14 ;(2)  ;X
LEFTARGIN   = 16 ;(1)  ;X
IMAGEOWS    = 18 ;(2)  ;X
IMAGEOLS    = 20 ;(1)  ;X
DISPLAYOW   = 22 ;(2)
DISPLAYOL   = 24 ;(1)
DISPLAYOWS  = 26 ;(2)
DISPLAYOLS  = 28 ;(1)
GOTOEXT     = 29 ;(1)  ;FLAG FOR SKIPPING KEYPRESS AFTER ERROR
WORK         = 112 ;(16);TEMPORARY WORK AREA, LOWEST LEVEL

;===MAIN===

MAIN = *
   ;** CHECK FOR A LARGE ENOUGH 
   SEC
   LDA #<BSSND
   CMP ACEEMOP+0
   LDA #>BSSND
   SBC ACEEMOP+1
   BCS +
   JMP MAINNIT
+  LDA #<TPASG
   LDY #>TPASG
   JSR EPUTS
DIE = *
   LDA #1
   LDX #0
   JMP EXIT
GDIE = *
   JSR GREXIT
   JMP DIE

TPASG = *
   .ASC "NSUFFICIENT PROGRAM SPACE TO RUN"
   .BYTE CHR,0

USAGE = *
   LDA #<USAGESG
   LDY #>USAGESG
   JSR EPUTS
   JMP DIE

USAGESG = *
   .ASC "USAGE: VBM [-HELP] FILE ..."
   .BYTE CHR,0

MAINNIT = *
   LDA #1
   LDY #0
   JSR GETARG
   LDY #0
   LDA (ZP),Y
   CMP #"-"
   BNE +
   JMP USAGE
+  JSR STARTRAPHICS
   LDA #0
   STA ARG+0
   STA ARG+1

   MAINEXT = *
   JSR CHECKTOP
   INC ARG+0
   BNE +
   INC ARG+1
+  LDA ARG+0
   LDY ARG+1
   JSR GETARG
   BEQ MAINXIT
   LDA ZP+0
   LDY ZP+1
   STA NAME+0
   STY NAME+1
   JSR VIEWONTROL
   JMP MAINEXT

MAINXIT = *
   JSR GREXIT
   RTS

STARTRAPHICS = *
   LDA #2
   LDX #$8
   LDY #$0E
   JSR GRSCREEN
   STA BMOLS
   STX ASPECT
   LDA SYSWORK+0
   LDY SYSWORK+1
   STA BMOWS+0
   STY BMOWS+1
   RTS

CHECKTOP = *
   JSR STOPKEY
   BCS +
   RTS
+  JSR GREXIT
   LDA #<STOPPEDSG
   LDY #>STOPPEDSG
   JSR EPUTS
   JMP DIE

   STOPPEDSG = *
   .ASC "<TOPPED>"
   .BYTE CHR,0

VIEWONTROL = *
   LDA #0
   STA TOPARGIN+0
   STA TOPARGIN+1
   STA LEFTARGIN

   VIEWONTROLOP = *
   LDA #0
   STA GOTOEXT
   JSR VIEW
   BIT GOTOEXT
   BPL +
   RTS
+  JSR GETKEY
   CMP #"Q"
   BNE +
-  JMP GDIE
+  CMP #$03
   BEQ -
+  CMP #17
   BEQ CURSOROWN
   CMP #29
   BEQ CURSORIGHT
   CMP #145
   BEQ CURSORP
   CMP #157
   BEQ CURSOREFT
   CMP #19
   BEQ CURSOROME
   CMP #"-"
   BEQ GOTOREV
   RTS

GOTOREV = *
   LDA ARG+1
   BNE +
   LDA ARG+0
   CMP #2
   BCC VIEWONTROLOP
+  SEC
   LDA ARG+0
   SBC #2
   STA ARG+0
   BCS +
   DEC ARG+1
+  RTS

CURSOROME = *
   LDA #0
   STA TOPARGIN+0
   STA TOPARGIN+1
   STA LEFTARGIN
   JMP VIEWONTROLOP

CURSOREFT = *
   LDA BMOLS
   LSR
   LSR
   STA WORK
   SEC
   LDA LEFTARGIN
   SBC WORK
   BCC +
   STA LEFTARGIN
+  JMP VIEWONTROLOP

CURSORIGHT = *
   LDA BMOLS
   LSR
   LSR
   STA WORK
   CLC
   ADC LEFTARGIN
   STA LEFTARGIN
   JMP VIEWONTROLOP

CURSORP = *
   LDA BMOWS+0
   LDY BMOWS+1
   STY WORK+1
   LSR WORK+1
   ROR
   LSR WORK+1
   ROR
   STA WORK+0
   SEC
   LDA TOPARGIN+0
   SBC WORK+0
   STA TOPARGIN+0
   LDA TOPARGIN+1
   SBC WORK+1
   STA TOPARGIN+1
   BCS +
   LDA #0
   STA TOPARGIN+0
   STA TOPARGIN+1
+  JMP VIEWONTROLOP

CURSOROWN = *
   LDA BMOWS+0
   LDY BMOWS+1
   STY WORK+1
   LSR WORK+1
   ROR
   LSR WORK+1
   ROR
   STA WORK+0
   CLC
   LDA TOPARGIN+0
   ADC WORK+0
   STA TOPARGIN+0
   LDA TOPARGIN+1
   ADC WORK+1
   STA TOPARGIN+1
   JMP VIEWONTROLOP

VIEW = *
   LDA #$AA
   JSR GRFILL
   JSR CONKEYAVAIL
   BCS +
   RTS
   ;** OPEN FILE
+  LDA NAME+0
   LDY NAME+1
   STA ZP+0
   STY ZP+1
   LDA #"R"
   JSR OPEN
   BCC +
   JSR GREXIT
   JSR ECHOAME
   LDA #<OPENRRSG
   LDY #>OPENRRSG
   JSR EPUTS
   JSR GETKEY
   LDA #$FF
   STA GOTOEXT
   JSR STARTRAPHICS
   RTS
+  STA INILE
   ;** CHECK AND EXTRACT HEADER INFORMATION
   LDA #8
   JSR BINEAD
   BCS INVALIDORMAT
   LDA INUF+0
   CMP #"B"
   BNE INVALIDORMAT
   LDA INUF+1
   CMP #"M"
   BNE INVALIDORMAT
   LDA INUF+2
   CMP #$CB
   BNE INVALIDORMAT
   LDA INUF+3
   CMP #2
   BNE INVALIDORMAT
   LDY INUF+4  ;HI/LO
   LDA INUF+5
   CLC
   ADC #7
   BCC +
   INY
+  STY WORK
   LSR WORK
   ROR
   LSR WORK
   ROR
   LSR WORK
   ROR
   STA IMAGEOLS
   LDY INUF+6  ;HI/LO
   LDA INUF+7
   STA IMAGEOWS+0
   STY IMAGEOWS+1
   ;** DISPLAY
   JSR VIEWODY
   ;** CLOSE
   LDA INILE
   JSR CLOSE
   RTS

   INVALIDORMAT = *
   JSR GREXIT
   JSR ECHOAME
   LDA #<INVALIDORMATSG
   LDY #>INVALIDORMATSG
   JSR EPUTS
   JSR GETKEY
   LDA #$FF
   STA GOTOEXT
   JSR STARTRAPHICS
   LDA INILE
   JSR CLOSE
   RTS
   INVALIDORMATSG = *
   .ASC ": INVALID  FORMAT, PRESS KEY"
   .BYTE CHR,0

   OPENRRSG = *
   .ASC ": CANNOT OPEN, PRESS KEY"
   .BYTE CHR,0

ECHOAME = *
   LDA NAME+0
   LDY NAME+1
   JSR EPUTS
   RTS

BINEADEN .BUF 1

BINEAD = *  ;( .=BYTES, INILE )
   STA BINEADEN
   LDA #<INUF
   LDY #>INUF
   STA ZP+0
   STY ZP+1
   LDX INILE
   LDA BINEADEN
   LDY #0
   JSR READ
   BEQ +
   BCS +
   CMP BINEADEN
   BNE +
   CLC
   RTS
+  SEC
   RTS

VIEWODY = *  ;( NO PUN INTENDED... )
   ;** SET DEFAULT DISPLAY MARGINS
   LDA #0
   STA DISPLAYOW+0
   STA DISPLAYOW+1
   STA DISPLAYOL

   FIDDLEOLS = *
   LDA BMOLS
   CMP IMAGEOLS
   BCC +
   LDA #0
   STA LEFTARGIN
   LDA IMAGEOLS
   STA DISPLAYOLS
   JMP FIDDLEOWS
+  LDA BMOLS
   STA DISPLAYOLS
   CLC
   LDA LEFTARGIN
   ADC BMOLS
   CMP IMAGEOLS
   BEQ FIDDLEOWS
   BCC FIDDLEOWS
   SEC
   LDA IMAGEOLS
   SBC BMOLS
   STA LEFTARGIN

   FIDDLEOWS = *
   LDA BMOWS+0
   CMP IMAGEOWS+0
   LDA BMOWS+1
   SBC IMAGEOWS+1
   BCC +
   LDA #0
   STA TOPARGIN+0
   STA TOPARGIN+1
   LDA IMAGEOWS+0
   LDY IMAGEOWS+1
   STA DISPLAYOWS+0
   STY DISPLAYOWS+1
   JMP FIDDLEISPLAYARGINS
+  LDA BMOWS+0
   LDY BMOWS+1
   STA DISPLAYOWS+0
   STY DISPLAYOWS+1
   CLC
   LDA TOPARGIN+0
   ADC BMOWS+0
   STA WORK+0
   LDA TOPARGIN+1
   ADC BMOWS+1
   STA WORK+1
   LDA IMAGEOWS+0
   CMP WORK+0
   LDA IMAGEOWS+1
   SBC WORK+1
   BCS FIDDLEISPLAYARGINS
   SEC
   LDA IMAGEOWS+0
   SBC BMOWS+0
   STA TOPARGIN+0
   LDA IMAGEOWS+1
   SBC BMOWS+1
   STA TOPARGIN+1

   FIDDLEISPLAYARGINS = *
   SEC
   LDA BMOLS
   SBC IMAGEOLS
   BCC +
   LSR
   STA DISPLAYOL
+  SEC
   LDA BMOWS+0
   SBC IMAGEOWS+0
   STA DISPLAYOW+0
   LDA BMOWS+1
   SBC IMAGEOWS+1
   STA DISPLAYOW+1
   PHP
   LSR DISPLAYOW+1
   ROR DISPLAYOW+0
   PLP
   BCS +
   LDA #0
   STA DISPLAYOW+0
   STA DISPLAYOW+1
+  NOP

   ;** SKIP TOP MARGIN
   LDA TOPARGIN+0
   LDY TOPARGIN+1
   LDX IMAGEOLS
   JSR SKIPIXELINES

   ;** DISPLAY MAIN PORTION OF IMAGE
   VIEWEXTINE = *
   JSR CHECKTOP
   LDA DISPLAYOWS+0
   ORA DISPLAYOWS+1
   BNE +
-  RTS
+  JSR CONKEYAVAIL
   BCC -
   LDX LEFTARGIN
   SEC
   LDA IMAGEOLS
   SBC LEFTARGIN
   SEC
   SBC DISPLAYOLS
   TAY
   LDA DISPLAYOLS
   JSR READIXELINE
   LDA DISPLAYOW+0
   LDY DISPLAYOW+1
   STA SYSWORK+0
   STY SYSWORK+1
   LDA #<PIXELUF
   LDY #>PIXELUF
   STA SYSWORK+2
   STY SYSWORK+3
   LDA DISPLAYOL
   LDX DISPLAYOLS
   LDY #1
   JSR GRLOAD
   INC DISPLAYOW+0
   BNE +
   INC DISPLAYOW+1
+  LDA DISPLAYOWS+0
   BNE +
   DEC DISPLAYOWS+1
+  DEC DISPLAYOWS+0
   JMP VIEWEXTINE

SKIPOUNT .BUF 2
SKIPYTES .BUF 1

SKIPIXELINES = * ;( .=LINES, .=LINEEN )
   STA SKIPOUNT+0
   STY SKIPOUNT+1
   STX SKIPYTES
-  LDA SKIPOUNT+0
   ORA SKIPOUNT+1
   BNE +
   RTS
+  LDA SKIPYTES
   JSR BINEAD
   LDA SKIPOUNT+0
   BNE +
   DEC SKIPOUNT+1
+  DEC SKIPOUNT+0
   JMP -

SKIPEFT  .BUF 1
PAYIRT   .BUF 1
SKIPIGHT .BUF 1

READIXELINE = * ;( .=LEFTKIP, .=PAYIRT, .=RIGHTKIP ) : PIXELUF
   STX SKIPEFT
   STA PAYIRT
   STY SKIPIGHT
   LDA SKIPEFT
   BEQ +
   JSR BINEAD
+  LDA PAYIRT
   BEQ +
   JSR BINEAD
   LDX PAYIRT
   DEX
-  LDA INUF,X
   EOR #$FF
   STA PIXELUF,X
   DEX
   BPL -
+  LDA SKIPIGHT
   BEQ +
   JSR BINEAD
+  RTS

;=== STANDARD LIBRARY ===

PUTS = *
   LDX #STDOUT
FPUTS = *
   STA ZP+0
   STY ZP+1
   LDY #$FF
-  INY
   LDA (ZP),Y
   BNE -
   TYA
   LDY #0
   JMP WRITE
EPUTS = *
   LDX #STDERR
   JMP FPUTS

EPUTCHAR = *
   LDX #STDERR
   JMP PUTC
PUTCHAR = *
   LDX #STDOUT
PUTC = *
   STA PUTCUFFER
   LDA #<PUTCUFFER
   LDY #>PUTCUFFER
   STA ZP+0
   STY ZP+1
   LDA #1
   LDY #0
   JMP WRITE
   PUTCUFFER .BUF 1

GETARG = *
   STY ZP+1
   ASL
   STA ZP+0
   ROL ZP+1
   CLC
   LDA ACERGV+0
   ADC ZP+0
   STA ZP+0
   LDA ACERGV+1
   ADC ZP+1
   STA ZP+1
   LDY #0
   LDA (ZP),Y
   TAX
   INY
   LDA (ZP),Y
   STX ZP+0
   STA ZP+1
   ORA ZP+0
   RTS

;===BSS===

BSS      = *
PIXELUF = BSS
INUF    = PIXELUF+80
BSSND   = INUF+256
