;*** WINDOW PROGRAM - BY RAIG RUCE - 21-EB-94

.SEQ ACEHEAD.S
.ORG ACEPPDDRESS
.OBJ "@0:WINDOW"

JMP MAIN
.BYTE ACE1,ACE2,ACE3
.BYTE 64,0  ;** STACK,RESERVED

SCANAL = $20
CHR = 13
ROWS .BUF 1
COLS .BUF 1
STARTOW .BUF 1
STARTOL .BUF 1

;===WINDOW===

MAIN = *
   JSR WINSIZE
   STA ROWS
   STX COLS
   LDA SYSWORK+0
   LDX SYSWORK+1
   STA STARTOW
   STX STARTOL
   ;** CHECK ARGUMENT COUNT
   LDA ACERGC+1
   BNE ENOUGHRGS
   LDA ACERGC+0
   CMP #2
   BCS ENOUGHRGS

USAGE = *
   LDA #<USAGESG
   LDY #>USAGESG
   JSR EPUTS
   JMP WINARMS

USAGESG = *
   .ASC "USAGE: WINDOW COLUMNS [ROWS [STARTOLUMN [STARTOW]]]"
   .BYTE CHR,0

ENOUGHRGS = *
   LDA #1
   LDY #0
   JSR GETARG
   BEQ MAININISH
   JSR SCANUM
   LDA SCANAL+0
   STA COLS

   LDA #2
   LDY #0
   JSR GETARG
   BEQ MAININISH
   JSR SCANUM
   LDA SCANAL+0
   STA ROWS

   LDA #3
   LDY #0
   JSR GETARG
   BEQ MAININISH
   JSR SCANUM
   LDA SCANAL+0
   STA STARTOL

   LDA #4
   LDY #0
   JSR GETARG
   BEQ MAININISH
   JSR SCANUM
   LDA SCANAL+0
   STA STARTOW

MAININISH = *
   LDA STARTOW
   LDX STARTOL
   STA SYSWORK+0
   STX SYSWORK+1
   LDA ROWS
   LDX COLS
   JSR WINSET
   BCS MAINRROR
   LDA #$80
   LDX #$B8
   JSR WINCLS

   WINARMS = *
   LDA COLS
   JSR PUTNUM
   LDA #","
   JSR PUTCHAR
   LDA ROWS
   JSR PUTNUM
   LDA #","
   JSR PUTCHAR
   LDA STARTOL
   JSR PUTNUM
   LDA #","
   JSR PUTCHAR
   LDA STARTOW
   JSR PUTNUM
   LDA #CHR
   JSR PUTCHAR
   RTS

MAINRROR = *
   LDA #<MAINRRORSG
   LDY #>MAINRRORSG
   JMP EPUTS
MAINRRORSG = *
   .ASC "WINSET: INVALID WINDOW PARAMETERS"
   .BYTE CHR,0

;******** STANDARD LIBRARY ********

PUTS = *
   LDX #STDOUT
FPUTS = *
   STA ZP+0
   STY ZP+1
   LDY #$FF
-  INY
   LDA (ZP),Y
   BNE -
   TYA
   LDY #0
   JMP WRITE
EPUTS = *
   LDX #STDERR
   JMP FPUTS

PUTCHAR = *
   LDX #STDOUT
PUTC = *
   STA PUTCUFFER
   LDA #<PUTCUFFER
   LDY #>PUTCUFFER
   STA ZP+0
   STY ZP+1
   LDA #1
   LDY #0
   JMP WRITE
   PUTCUFFER .BUF 1

GETCHAR = *
   LDX #STDIN
GETC = *
   LDA #<GETCUFFER
   LDY #>GETCUFFER
   STA ZP+0
   STY ZP+1
   LDA #1
   LDY #0
   JSR READ
   BEQ +
   LDA GETCUFFER
   RTS
+  SEC
   RTS
   GETCUFFER .BUF 1

NUMBUF .BUF 11

PUTNUM = *
   STA $30
   LDA #0
   STA $31
   STA $32
   STA $33
   LDA #<NUMBUF
   LDY #>NUMBUF
   STA ZP+0
   STY ZP+1
   LDA #1
   LDX #$30
   JSR UTOA
   LDA #<NUMBUF
   LDY #>NUMBUF
   STA ZP+0
   STY ZP+1
   JSR PUTS
   RTS

GETARG = *
   STY ZP+1
   ASL
   STA ZP+0
   ROL ZP+1
   CLC
   LDA ACERGV
   ADC ZP+0
   STA ZP+0
   LDA ACERGV+1
   ADC ZP+1
   STA ZP+1
   LDY #0
   LDA (ZP),Y
   TAX
   INY
   LDA (ZP),Y
   STX ZP+0
   STA ZP+1
   ORA ZP+0
   RTS

SCANIGIT .BUF 1
SCANAVE .BUF 4
SCANEMP .BUF 1
SCANNDEX .BUF 1
SCANNYTHING .BUF 1

SCANUM = *  ;( (ZP)=NUMTR ) : .=SCAN, [SCANAL]=NUM, .=ERR
   LDY #0
   LDX #3
   LDA #0
-  STA SCANAL,X
   DEX
   BPL -
   LDA #0
   STA SCANNYTHING
-  LDA (ZP),Y
   CMP #" "
   BNE SCANUMEXT
   INY
   BNE -
   SEC
   RTS

   SCANUMEXT = *
   LDA (ZP),Y
   CMP #"0"
   BCC +
   CMP #"9"+1
   BCC ++
+  LDA SCANNYTHING
   BEQ SCANRROR
   CLC
   RTS
+  AND #$0F
   STA SCANIGIT
   LDA #$FF
   STA SCANNYTHING
   ;** TIMES TEN
   STY SCANEMP
   LDX #3
-  LDA SCANAL,X
   STA SCANAVE,X
   DEX
   BPL -
   LDA #2
   STA SCANNDEX
-  CLC
   LDY #4
   LDX #0
-  ROL SCANAL,X
   INX
   DEY
   BNE -
   BCS SCANRROR
   DEC SCANNDEX
   BNE --
   CLC
   LDY #4
   LDX #0
-  LDA SCANAL,X
   ADC SCANAVE,X
   STA SCANAL,X
   INX
   DEY
   BNE -
   BCS SCANRROR
   CLC
   LDY #4
   LDX #0
-  ROL SCANAL,X
   INX
   DEY
   BNE -
   BCS SCANRROR
   CLC
   LDY #4
   LDX #0
   LDA SCANIGIT
-  ADC SCANAL,X
   STA SCANAL,X
   LDA #0
   INX
   DEY
   BNE -
   BCS SCANRROR

   LDY SCANEMP
   INY
   BEQ SCANRROR
   JMP SCANUMEXT

   SCANRROR = *
   SEC
   RTS

;===THE END===
BSS = *
